/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 2 "l2tp_config_parse.y"

#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <netdb.h>
#include <ctype.h>
#include <errno.h>
#include <stdlib.h>
#include <syslog.h>

#include "l2tp_config_types.h"

#include "l2tp_rpc.h"

static struct l2tp_api_system_msg_data system_config;
static struct l2tp_api_peer_profile_msg_data peer_profile;
static struct l2tp_api_tunnel_profile_msg_data tunnel_profile;
static struct l2tp_api_session_profile_msg_data session_profile;
static struct l2tp_api_ppp_profile_msg_data ppp_profile;
static struct l2tp_api_tunnel_msg_data tunnel;
static struct l2tp_api_session_msg_data session;

extern void l2tp_log(int level, char *fmt, ...);
extern void yyfatal(const char *s);


#line 104 "l2tp_config_parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "l2tp_config_parse.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_SYSTEM = 3,                     /* SYSTEM  */
  YYSYMBOL_TUNNEL = 4,                     /* TUNNEL  */
  YYSYMBOL_SESSION = 5,                    /* SESSION  */
  YYSYMBOL_PROFILE = 6,                    /* PROFILE  */
  YYSYMBOL_PEER = 7,                       /* PEER  */
  YYSYMBOL_PPP = 8,                        /* PPP  */
  YYSYMBOL_CREATE = 9,                     /* CREATE  */
  YYSYMBOL_MODIFY = 10,                    /* MODIFY  */
  YYSYMBOL_DIGITAL_ANALOG = 11,            /* DIGITAL_ANALOG  */
  YYSYMBOL_TUNNEL_AUTH_MODE = 12,          /* TUNNEL_AUTH_MODE  */
  YYSYMBOL_PEER_IPADDR = 13,               /* PEER_IPADDR  */
  YYSYMBOL_LAC_LNS = 14,                   /* LAC_LNS  */
  YYSYMBOL_TUNNEL_ID = 15,                 /* TUNNEL_ID  */
  YYSYMBOL_TUNNEL_NAME = 16,               /* TUNNEL_NAME  */
  YYSYMBOL_SESSION_ID = 17,                /* SESSION_ID  */
  YYSYMBOL_SESSION_NAME = 18,              /* SESSION_NAME  */
  YYSYMBOL_UDP_PORT = 19,                  /* UDP_PORT  */
  YYSYMBOL_TRACE_FLAGS = 20,               /* TRACE_FLAGS  */
  YYSYMBOL_MAX_TUNNELS = 21,               /* MAX_TUNNELS  */
  YYSYMBOL_MAX_SESSIONS = 22,              /* MAX_SESSIONS  */
  YYSYMBOL_DRAIN_TUNNELS = 23,             /* DRAIN_TUNNELS  */
  YYSYMBOL_TUNNEL_ESTABLISH_TIMEOUT = 24,  /* TUNNEL_ESTABLISH_TIMEOUT  */
  YYSYMBOL_SESSION_ESTABLISH_TIMEOUT = 25, /* SESSION_ESTABLISH_TIMEOUT  */
  YYSYMBOL_TUNNEL_PERSIST_PEND_TIMEOUT = 26, /* TUNNEL_PERSIST_PEND_TIMEOUT  */
  YYSYMBOL_SESSION_PERSIST_PEND_TIMEOUT = 27, /* SESSION_PERSIST_PEND_TIMEOUT  */
  YYSYMBOL_DENY_LOCAL_TUNNEL_CREATES = 28, /* DENY_LOCAL_TUNNEL_CREATES  */
  YYSYMBOL_DENY_REMOTE_TUNNEL_CREATES = 29, /* DENY_REMOTE_TUNNEL_CREATES  */
  YYSYMBOL_HIDE_AVPS = 30,                 /* HIDE_AVPS  */
  YYSYMBOL_OUR_ADDR = 31,                  /* OUR_ADDR  */
  YYSYMBOL_PEER_ADDR = 32,                 /* PEER_ADDR  */
  YYSYMBOL_OUR_UDP_PORT = 33,              /* OUR_UDP_PORT  */
  YYSYMBOL_PEER_UDP_PORT = 34,             /* PEER_UDP_PORT  */
  YYSYMBOL_CONFIG_ID = 35,                 /* CONFIG_ID  */
  YYSYMBOL_AUTH_MODE = 36,                 /* AUTH_MODE  */
  YYSYMBOL_FRAMING_CAP = 37,               /* FRAMING_CAP  */
  YYSYMBOL_BEARER_CAP = 38,                /* BEARER_CAP  */
  YYSYMBOL_USE_TIEBREAKER = 39,            /* USE_TIEBREAKER  */
  YYSYMBOL_ALLOW_PPP_PROXY = 40,           /* ALLOW_PPP_PROXY  */
  YYSYMBOL_USE_PPP_PROXY = 41,             /* USE_PPP_PROXY  */
  YYSYMBOL_USE_UDP_CHECKSUMS = 42,         /* USE_UDP_CHECKSUMS  */
  YYSYMBOL_HELLO_TIMEOUT = 43,             /* HELLO_TIMEOUT  */
  YYSYMBOL_MAX_RETRIES = 44,               /* MAX_RETRIES  */
  YYSYMBOL_RX_WINDOW_SIZE = 45,            /* RX_WINDOW_SIZE  */
  YYSYMBOL_TX_WINDOW_SIZE = 46,            /* TX_WINDOW_SIZE  */
  YYSYMBOL_RETRY_TIMEOUT = 47,             /* RETRY_TIMEOUT  */
  YYSYMBOL_IDLE_TIMEOUT = 48,              /* IDLE_TIMEOUT  */
  YYSYMBOL_DO_PMTU_DISCOVERY = 49,         /* DO_PMTU_DISCOVERY  */
  YYSYMBOL_PERSIST = 50,                   /* PERSIST  */
  YYSYMBOL_MTU = 51,                       /* MTU  */
  YYSYMBOL_SECRET = 52,                    /* SECRET  */
  YYSYMBOL_HOST_NAME = 53,                 /* HOST_NAME  */
  YYSYMBOL_TUNNEL_PROFILE_NAME = 54,       /* TUNNEL_PROFILE_NAME  */
  YYSYMBOL_PEER_PROFILE_NAME = 55,         /* PEER_PROFILE_NAME  */
  YYSYMBOL_SESSION_PROFILE_NAME = 56,      /* SESSION_PROFILE_NAME  */
  YYSYMBOL_PPP_PROFILE_NAME = 57,          /* PPP_PROFILE_NAME  */
  YYSYMBOL_INTERFACE_NAME = 58,            /* INTERFACE_NAME  */
  YYSYMBOL_SESSION_TYPE = 59,              /* SESSION_TYPE  */
  YYSYMBOL_USER_NAME = 60,                 /* USER_NAME  */
  YYSYMBOL_USER_PASSWORD = 61,             /* USER_PASSWORD  */
  YYSYMBOL_PRIV_GROUP_ID = 62,             /* PRIV_GROUP_ID  */
  YYSYMBOL_PROFILE_NAME = 63,              /* PROFILE_NAME  */
  YYSYMBOL_SEQUENCING_REQUIRED = 64,       /* SEQUENCING_REQUIRED  */
  YYSYMBOL_USE_SEQUENCE_NUMBERS = 65,      /* USE_SEQUENCE_NUMBERS  */
  YYSYMBOL_NO_PPP = 66,                    /* NO_PPP  */
  YYSYMBOL_REORDER_TIMEOUT = 67,           /* REORDER_TIMEOUT  */
  YYSYMBOL_FRAMING_TYPE = 68,              /* FRAMING_TYPE  */
  YYSYMBOL_BEARER_TYPE = 69,               /* BEARER_TYPE  */
  YYSYMBOL_MINIMUM_BPS = 70,               /* MINIMUM_BPS  */
  YYSYMBOL_MAXIMUM_BPS = 71,               /* MAXIMUM_BPS  */
  YYSYMBOL_CONNECT_SPEED = 72,             /* CONNECT_SPEED  */
  YYSYMBOL_PEER_PORT = 73,                 /* PEER_PORT  */
  YYSYMBOL_WE_CAN_BE_LAC = 74,             /* WE_CAN_BE_LAC  */
  YYSYMBOL_WE_CAN_BE_LNS = 75,             /* WE_CAN_BE_LNS  */
  YYSYMBOL_DEFAULT_TUNNEL_PROFILE_NAME = 76, /* DEFAULT_TUNNEL_PROFILE_NAME  */
  YYSYMBOL_DEFAULT_SESSION_PROFILE_NAME = 77, /* DEFAULT_SESSION_PROFILE_NAME  */
  YYSYMBOL_DEFAULT_PPP_PROFILE_NAME = 78,  /* DEFAULT_PPP_PROFILE_NAME  */
  YYSYMBOL_NETMASK = 79,                   /* NETMASK  */
  YYSYMBOL_ASYNCMAP = 80,                  /* ASYNCMAP  */
  YYSYMBOL_MRU = 81,                       /* MRU  */
  YYSYMBOL_AUTH_FLAGS = 82,                /* AUTH_FLAGS  */
  YYSYMBOL_SYNC_MODE = 83,                 /* SYNC_MODE  */
  YYSYMBOL_CHAP_INTERVAL = 84,             /* CHAP_INTERVAL  */
  YYSYMBOL_CHAP_MAX_CHALLENGE = 85,        /* CHAP_MAX_CHALLENGE  */
  YYSYMBOL_CHAP_RESTART = 86,              /* CHAP_RESTART  */
  YYSYMBOL_PAP_MAX_AUTH_REQUESTS = 87,     /* PAP_MAX_AUTH_REQUESTS  */
  YYSYMBOL_PAP_RESTART_INTERVAL = 88,      /* PAP_RESTART_INTERVAL  */
  YYSYMBOL_PAP_TIMEOUT = 89,               /* PAP_TIMEOUT  */
  YYSYMBOL_IPCP_MAX_CONFIG_REQUESTS = 90,  /* IPCP_MAX_CONFIG_REQUESTS  */
  YYSYMBOL_IPCP_MAX_CONFIG_NAKS = 91,      /* IPCP_MAX_CONFIG_NAKS  */
  YYSYMBOL_IPCP_MAX_TERMINATE_REQUESTS = 92, /* IPCP_MAX_TERMINATE_REQUESTS  */
  YYSYMBOL_IPCP_RETRANSMIT_INTERVAL = 93,  /* IPCP_RETRANSMIT_INTERVAL  */
  YYSYMBOL_LCP_ECHO_FAILURE_COUNT = 94,    /* LCP_ECHO_FAILURE_COUNT  */
  YYSYMBOL_LCP_ECHO_INTERVAL = 95,         /* LCP_ECHO_INTERVAL  */
  YYSYMBOL_LCP_MAX_CONFIG_REQUESTS = 96,   /* LCP_MAX_CONFIG_REQUESTS  */
  YYSYMBOL_LCP_MAX_CONFIG_NAKS = 97,       /* LCP_MAX_CONFIG_NAKS  */
  YYSYMBOL_LCP_MAX_TERMINATE_REQUESTS = 98, /* LCP_MAX_TERMINATE_REQUESTS  */
  YYSYMBOL_LCP_RETRANSMIT_INTERVAL = 99,   /* LCP_RETRANSMIT_INTERVAL  */
  YYSYMBOL_MAX_CONNECT_TIME = 100,         /* MAX_CONNECT_TIME  */
  YYSYMBOL_MAX_FAILURE_COUNT = 101,        /* MAX_FAILURE_COUNT  */
  YYSYMBOL_LOCAL_IPADDR = 102,             /* LOCAL_IPADDR  */
  YYSYMBOL_REMOTE_IPADDR = 103,            /* REMOTE_IPADDR  */
  YYSYMBOL_DNS_IPADDR_PRI = 104,           /* DNS_IPADDR_PRI  */
  YYSYMBOL_DNS_IPADDR_SEC = 105,           /* DNS_IPADDR_SEC  */
  YYSYMBOL_WINS_IPADDR_PRI = 106,          /* WINS_IPADDR_PRI  */
  YYSYMBOL_WINS_IPADDR_SEC = 107,          /* WINS_IPADDR_SEC  */
  YYSYMBOL_IP_POOL_NAME = 108,             /* IP_POOL_NAME  */
  YYSYMBOL_USE_RADIUS = 109,               /* USE_RADIUS  */
  YYSYMBOL_RADIUS_HINT = 110,              /* RADIUS_HINT  */
  YYSYMBOL_USE_AS_DEFAULT_ROUTE = 111,     /* USE_AS_DEFAULT_ROUTE  */
  YYSYMBOL_MULTILINK = 112,                /* MULTILINK  */
  YYSYMBOL_PROXY_ARP = 113,                /* PROXY_ARP  */
  YYSYMBOL_EOT = 114,                      /* EOT  */
  YYSYMBOL_SLASH = 115,                    /* SLASH  */
  YYSYMBOL_BLCL = 116,                     /* BLCL  */
  YYSYMBOL_ELCL = 117,                     /* ELCL  */
  YYSYMBOL_EQUALS = 118,                   /* EQUALS  */
  YYSYMBOL_DECSTRING = 119,                /* DECSTRING  */
  YYSYMBOL_STRING = 120,                   /* STRING  */
  YYSYMBOL_HEXSTRING = 121,                /* HEXSTRING  */
  YYSYMBOL_QUOTEDSTRING = 122,             /* QUOTEDSTRING  */
  YYSYMBOL_BOOL = 123,                     /* BOOL  */
  YYSYMBOL_IPADDRESS = 124,                /* IPADDRESS  */
  YYSYMBOL_INITIAL_RCVD_LCP_CONFREQ = 125, /* INITIAL_RCVD_LCP_CONFREQ  */
  YYSYMBOL_CALLING_NUMBER = 126,           /* CALLING_NUMBER  */
  YYSYMBOL_PROXY_AUTH_NAME = 127,          /* PROXY_AUTH_NAME  */
  YYSYMBOL_SUB_ADDRESS = 128,              /* SUB_ADDRESS  */
  YYSYMBOL_PROXY_AUTH_TYPE = 129,          /* PROXY_AUTH_TYPE  */
  YYSYMBOL_PROXY_AUTH_RESPONSE = 130,      /* PROXY_AUTH_RESPONSE  */
  YYSYMBOL_LAST_RCVD_LCP_CONFREQ = 131,    /* LAST_RCVD_LCP_CONFREQ  */
  YYSYMBOL_CALLED_NUMBER = 132,            /* CALLED_NUMBER  */
  YYSYMBOL_PROXY_AUTH_CHALLENGE = 133,     /* PROXY_AUTH_CHALLENGE  */
  YYSYMBOL_LAST_SENT_LCP_CONFREQ = 134,    /* LAST_SENT_LCP_CONFREQ  */
  YYSYMBOL_AUTH_PAP = 135,                 /* AUTH_PAP  */
  YYSYMBOL_AUTH_CHAP = 136,                /* AUTH_CHAP  */
  YYSYMBOL_AUTH_MSCHAPV1 = 137,            /* AUTH_MSCHAPV1  */
  YYSYMBOL_AUTH_MSCHAPV2 = 138,            /* AUTH_MSCHAPV2  */
  YYSYMBOL_AUTH_EAP = 139,                 /* AUTH_EAP  */
  YYSYMBOL_AUTH_NOAUTH = 140,              /* AUTH_NOAUTH  */
  YYSYMBOL_AUTH_PEER = 141,                /* AUTH_PEER  */
  YYSYMBOL_SRC_IPADDR = 142,               /* SRC_IPADDR  */
  YYSYMBOL_DEST_IPADDR = 143,              /* DEST_IPADDR  */
  YYSYMBOL_LOCAL_NAME = 144,               /* LOCAL_NAME  */
  YYSYMBOL_REMOTE_NAME = 145,              /* REMOTE_NAME  */
  YYSYMBOL_YYACCEPT = 146,                 /* $accept  */
  YYSYMBOL_commands = 147,                 /* commands  */
  YYSYMBOL_command = 148,                  /* command  */
  YYSYMBOL_system_command = 149,           /* system_command  */
  YYSYMBOL_system_statements = 150,        /* system_statements  */
  YYSYMBOL_system_statement = 151,         /* system_statement  */
  YYSYMBOL_peer_profile_command = 152,     /* peer_profile_command  */
  YYSYMBOL_peer_profile_create_command = 153, /* peer_profile_create_command  */
  YYSYMBOL_peer_profile_modify_command = 154, /* peer_profile_modify_command  */
  YYSYMBOL_peer_profile_statements = 155,  /* peer_profile_statements  */
  YYSYMBOL_peer_profile_statement = 156,   /* peer_profile_statement  */
  YYSYMBOL_tunnel_profile_command = 157,   /* tunnel_profile_command  */
  YYSYMBOL_tunnel_profile_create_command = 158, /* tunnel_profile_create_command  */
  YYSYMBOL_tunnel_profile_modify_command = 159, /* tunnel_profile_modify_command  */
  YYSYMBOL_tunnel_profile_statements = 160, /* tunnel_profile_statements  */
  YYSYMBOL_tunnel_profile_statement = 161, /* tunnel_profile_statement  */
  YYSYMBOL_session_profile_command = 162,  /* session_profile_command  */
  YYSYMBOL_session_profile_create_command = 163, /* session_profile_create_command  */
  YYSYMBOL_session_profile_modify_command = 164, /* session_profile_modify_command  */
  YYSYMBOL_session_profile_statements = 165, /* session_profile_statements  */
  YYSYMBOL_session_profile_statement = 166, /* session_profile_statement  */
  YYSYMBOL_ppp_profile_command = 167,      /* ppp_profile_command  */
  YYSYMBOL_ppp_profile_create_command = 168, /* ppp_profile_create_command  */
  YYSYMBOL_ppp_profile_modify_command = 169, /* ppp_profile_modify_command  */
  YYSYMBOL_ppp_profile_statements = 170,   /* ppp_profile_statements  */
  YYSYMBOL_ppp_profile_statement = 171,    /* ppp_profile_statement  */
  YYSYMBOL_tunnel_command = 172,           /* tunnel_command  */
  YYSYMBOL_tunnel_create_command = 173,    /* tunnel_create_command  */
  YYSYMBOL_tunnel_modify_command = 174,    /* tunnel_modify_command  */
  YYSYMBOL_tunnel_statements = 175,        /* tunnel_statements  */
  YYSYMBOL_tunnel_statement = 176,         /* tunnel_statement  */
  YYSYMBOL_session_command = 177,          /* session_command  */
  YYSYMBOL_session_create_command = 178,   /* session_create_command  */
  YYSYMBOL_session_modify_command = 179,   /* session_modify_command  */
  YYSYMBOL_session_statements = 180,       /* session_statements  */
  YYSYMBOL_session_statement = 181         /* session_statement  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   759

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  146
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  36
/* YYNRULES -- Number of rules.  */
#define YYNRULES  257
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  626

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   400


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   179,   179,   180,   181,   187,   188,   189,   190,   191,
     192,   193,   197,   208,   209,   213,   218,   223,   228,   233,
     238,   243,   248,   253,   258,   266,   267,   271,   286,   301,
     302,   306,   310,   314,   321,   326,   333,   350,   356,   362,
     368,   374,   380,   389,   390,   394,   409,   424,   425,   429,
     433,   437,   442,   455,   471,   487,   492,   497,   502,   507,
     512,   517,   522,   528,   534,   539,   544,   549,   555,   561,
     566,   573,   580,   585,   590,   596,   602,   608,   614,   620,
     626,   631,   639,   640,   644,   659,   674,   675,   679,   683,
     687,   692,   697,   703,   709,   725,   731,   737,   754,   771,
     776,   781,   798,   803,   808,   813,   821,   822,   826,   841,
     856,   857,   861,   865,   869,   874,   879,   884,   889,   894,
     900,   906,   915,   924,   933,   942,   951,   960,   969,   982,
     987,   992,   997,  1002,  1007,  1012,  1017,  1022,  1027,  1032,
    1037,  1042,  1047,  1052,  1057,  1062,  1067,  1072,  1077,  1084,
    1091,  1098,  1105,  1112,  1119,  1125,  1131,  1136,  1141,  1146,
    1152,  1158,  1164,  1173,  1174,  1178,  1191,  1204,  1205,  1209,
    1214,  1221,  1228,  1233,  1238,  1251,  1267,  1283,  1288,  1293,
    1298,  1303,  1308,  1313,  1318,  1323,  1328,  1334,  1340,  1345,
    1350,  1355,  1361,  1367,  1372,  1378,  1384,  1389,  1395,  1401,
    1407,  1413,  1419,  1425,  1431,  1437,  1442,  1447,  1453,  1462,
    1463,  1467,  1480,  1493,  1494,  1498,  1503,  1508,  1514,  1520,
    1535,  1541,  1547,  1563,  1579,  1584,  1589,  1605,  1610,  1627,
    1633,  1639,  1645,  1651,  1659,  1665,  1673,  1679,  1687,  1693,
    1699,  1705,  1711,  1717,  1723,  1729,  1734,  1739,  1744,  1750,
    1756,  1760,  1766,  1772,  1776,  1782,  1788,  1794
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "SYSTEM", "TUNNEL",
  "SESSION", "PROFILE", "PEER", "PPP", "CREATE", "MODIFY",
  "DIGITAL_ANALOG", "TUNNEL_AUTH_MODE", "PEER_IPADDR", "LAC_LNS",
  "TUNNEL_ID", "TUNNEL_NAME", "SESSION_ID", "SESSION_NAME", "UDP_PORT",
  "TRACE_FLAGS", "MAX_TUNNELS", "MAX_SESSIONS", "DRAIN_TUNNELS",
  "TUNNEL_ESTABLISH_TIMEOUT", "SESSION_ESTABLISH_TIMEOUT",
  "TUNNEL_PERSIST_PEND_TIMEOUT", "SESSION_PERSIST_PEND_TIMEOUT",
  "DENY_LOCAL_TUNNEL_CREATES", "DENY_REMOTE_TUNNEL_CREATES", "HIDE_AVPS",
  "OUR_ADDR", "PEER_ADDR", "OUR_UDP_PORT", "PEER_UDP_PORT", "CONFIG_ID",
  "AUTH_MODE", "FRAMING_CAP", "BEARER_CAP", "USE_TIEBREAKER",
  "ALLOW_PPP_PROXY", "USE_PPP_PROXY", "USE_UDP_CHECKSUMS", "HELLO_TIMEOUT",
  "MAX_RETRIES", "RX_WINDOW_SIZE", "TX_WINDOW_SIZE", "RETRY_TIMEOUT",
  "IDLE_TIMEOUT", "DO_PMTU_DISCOVERY", "PERSIST", "MTU", "SECRET",
  "HOST_NAME", "TUNNEL_PROFILE_NAME", "PEER_PROFILE_NAME",
  "SESSION_PROFILE_NAME", "PPP_PROFILE_NAME", "INTERFACE_NAME",
  "SESSION_TYPE", "USER_NAME", "USER_PASSWORD", "PRIV_GROUP_ID",
  "PROFILE_NAME", "SEQUENCING_REQUIRED", "USE_SEQUENCE_NUMBERS", "NO_PPP",
  "REORDER_TIMEOUT", "FRAMING_TYPE", "BEARER_TYPE", "MINIMUM_BPS",
  "MAXIMUM_BPS", "CONNECT_SPEED", "PEER_PORT", "WE_CAN_BE_LAC",
  "WE_CAN_BE_LNS", "DEFAULT_TUNNEL_PROFILE_NAME",
  "DEFAULT_SESSION_PROFILE_NAME", "DEFAULT_PPP_PROFILE_NAME", "NETMASK",
  "ASYNCMAP", "MRU", "AUTH_FLAGS", "SYNC_MODE", "CHAP_INTERVAL",
  "CHAP_MAX_CHALLENGE", "CHAP_RESTART", "PAP_MAX_AUTH_REQUESTS",
  "PAP_RESTART_INTERVAL", "PAP_TIMEOUT", "IPCP_MAX_CONFIG_REQUESTS",
  "IPCP_MAX_CONFIG_NAKS", "IPCP_MAX_TERMINATE_REQUESTS",
  "IPCP_RETRANSMIT_INTERVAL", "LCP_ECHO_FAILURE_COUNT",
  "LCP_ECHO_INTERVAL", "LCP_MAX_CONFIG_REQUESTS", "LCP_MAX_CONFIG_NAKS",
  "LCP_MAX_TERMINATE_REQUESTS", "LCP_RETRANSMIT_INTERVAL",
  "MAX_CONNECT_TIME", "MAX_FAILURE_COUNT", "LOCAL_IPADDR", "REMOTE_IPADDR",
  "DNS_IPADDR_PRI", "DNS_IPADDR_SEC", "WINS_IPADDR_PRI", "WINS_IPADDR_SEC",
  "IP_POOL_NAME", "USE_RADIUS", "RADIUS_HINT", "USE_AS_DEFAULT_ROUTE",
  "MULTILINK", "PROXY_ARP", "EOT", "SLASH", "BLCL", "ELCL", "EQUALS",
  "DECSTRING", "STRING", "HEXSTRING", "QUOTEDSTRING", "BOOL", "IPADDRESS",
  "INITIAL_RCVD_LCP_CONFREQ", "CALLING_NUMBER", "PROXY_AUTH_NAME",
  "SUB_ADDRESS", "PROXY_AUTH_TYPE", "PROXY_AUTH_RESPONSE",
  "LAST_RCVD_LCP_CONFREQ", "CALLED_NUMBER", "PROXY_AUTH_CHALLENGE",
  "LAST_SENT_LCP_CONFREQ", "AUTH_PAP", "AUTH_CHAP", "AUTH_MSCHAPV1",
  "AUTH_MSCHAPV2", "AUTH_EAP", "AUTH_NOAUTH", "AUTH_PEER", "SRC_IPADDR",
  "DEST_IPADDR", "LOCAL_NAME", "REMOTE_NAME", "$accept", "commands",
  "command", "system_command", "system_statements", "system_statement",
  "peer_profile_command", "peer_profile_create_command",
  "peer_profile_modify_command", "peer_profile_statements",
  "peer_profile_statement", "tunnel_profile_command",
  "tunnel_profile_create_command", "tunnel_profile_modify_command",
  "tunnel_profile_statements", "tunnel_profile_statement",
  "session_profile_command", "session_profile_create_command",
  "session_profile_modify_command", "session_profile_statements",
  "session_profile_statement", "ppp_profile_command",
  "ppp_profile_create_command", "ppp_profile_modify_command",
  "ppp_profile_statements", "ppp_profile_statement", "tunnel_command",
  "tunnel_create_command", "tunnel_modify_command", "tunnel_statements",
  "tunnel_statement", "session_command", "session_create_command",
  "session_modify_command", "session_statements", "session_statement", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400
};
#endif

#define YYPACT_NINF (-119)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -111,  -119,     6,  -119,    -2,    99,   105,    33,    49,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
       7,  -119,  -119,    37,  -119,  -119,    51,   160,   109,  -119,
    -119,   -15,    29,  -119,  -119,   414,   447,  -119,  -119,  -119,
    -119,  -106,   -92,   -68,   -48,   -35,   -24,   -21,    -8,    21,
      31,  -119,  -119,   314,   352,    36,    57,   101,   103,   117,
     131,   152,   185,   186,   187,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   212,   213,   217,   219,  -119,   220,   221,  -119,  -119,
     382,   529,   222,   223,   224,   225,   227,   228,   231,   237,
     246,   250,   255,   257,   258,   260,   261,   262,   263,   265,
     266,   269,   275,   288,  -119,   292,   293,   294,   295,   296,
     298,   299,   300,   301,   302,  -119,  -119,    39,    44,    93,
     188,    -3,    32,   108,   -20,   303,   305,   306,   307,     2,
     183,   309,   315,   317,   318,   319,   320,   322,   324,   325,
     340,   341,   342,   343,   350,   351,   369,   371,   372,   373,
     374,   375,   379,   380,   381,   383,  -119,   384,   385,  -119,
    -119,   401,  -118,   402,   403,   347,   404,   405,   406,   407,
     409,   410,   377,   408,   411,   413,   416,   417,   418,   419,
     431,   428,   429,   434,   -66,   -32,   -31,   -16,    -1,     0,
       4,   297,   430,   415,   437,   438,   439,   440,   441,   442,
     444,   445,   446,   448,   449,   450,   451,   453,  -119,  -119,
    -119,   463,    20,   464,    25,   465,   462,    26,    30,   467,
      35,    40,    41,    45,   466,   479,   480,   471,   484,   485,
     487,   488,   489,    38,   106,   490,   145,   491,    43,    92,
     147,   492,   493,   494,   497,   498,   499,   500,   501,   502,
     503,  -119,  -119,  -119,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   526,   527,   528,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,  -119,   543,   544,   545,   546,   547,   548,   549,   550,
     551,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,   552,   553,   554,   555,   556,   558,   559,
     560,   561,   562,   563,   557,   564,   568,   569,   570,   571,
     572,   573,    46,    89,    90,    94,    95,    98,   567,   574,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
     575,   576,   102,   577,   120,   121,   578,   579,   580,   581,
     584,   585,   587,   588,   589,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,   586,   591,
     124,   125,   128,   132,   593,   590,   594,   596,   597,   133,
     598,   599,   600,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   595,   620,   621,   622,   623,   624,   136,   626,   137,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     140,   141,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     3,     0,     1,     0,     0,     0,     0,     0,     4,
       5,     6,    25,    26,     7,    43,    44,     8,    82,    83,
       9,   106,   107,    10,   163,   164,    11,   209,   210,    13,
       0,   167,   167,     0,   213,   213,     0,     0,     0,    47,
      47,     0,     0,    86,    86,     0,     0,    29,    29,   110,
     110,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    14,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,     0,   168,   166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   214,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,     0,     0,    48,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,    87,
      85,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,    30,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   111,   109,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   197,   198,   189,   196,   169,   173,   185,   172,   174,
     175,   176,   177,   188,   190,   179,   180,   181,   182,   183,
     184,   205,   178,   206,   186,   187,   191,   192,   199,   200,
     201,   202,   203,   204,   207,   208,   194,   195,   170,   171,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   250,   248,   249,   253,   251,
     252,   215,   227,   217,   218,   254,   255,   219,   241,   242,
     243,   244,   220,   221,   256,   257,   216,   245,   246,   247,
     222,   223,   224,   225,   226,   238,   233,   232,   229,   237,
     236,   228,   231,   240,   235,   234,   230,   239,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    65,    69,    51,    72,    73,    52,    53,    54,
      55,    64,    66,    56,    57,    58,    59,    60,    61,    80,
      81,    62,    63,    67,    68,    74,    75,    76,    77,    78,
      79,    49,    50,    70,    71,    90,   102,    92,    93,    94,
      95,    96,    88,    89,    91,   103,   104,   105,    97,    98,
      99,   100,   101,    33,    36,    37,    38,    39,    40,    41,
      42,    31,    32,    34,    35,   114,   135,   117,   112,   113,
     115,   116,   128,   129,   130,   131,   132,   133,   134,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   152,   153,   148,   149,   150,   151,   154,   155,   118,
     119,   120,   156,   157,   158,   121,   122,   123,   124,   125,
     126,   127,   159,   160,   161,   162
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,   478,
    -119,  -119,  -119,  -119,   525,  -119,  -119,  -119,  -119,   637,
    -119,  -119,  -119,  -119,   643,  -119,  -119,  -119,  -119,   638,
    -119,  -119,  -119,  -119,   647,  -119
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     9,    10,    38,    62,    11,    12,    13,   137,
     272,    14,    15,    16,    63,   179,    17,    18,    19,   100,
     229,    20,    21,    22,   139,   321,    23,    24,    25,    41,
      98,    26,    27,    28,    45,   135
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      65,    66,   361,     1,   362,    67,     3,    68,    29,     4,
       5,     6,   141,     7,     8,    69,    39,    40,    70,    71,
      72,    73,    74,    75,    76,    77,   142,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    36,
      90,    91,    92,    93,    65,    66,    43,    44,    94,    67,
     143,    68,   263,   264,   384,    37,   385,   263,   264,    69,
      47,    48,    70,    71,    72,    73,    74,    75,    76,    77,
     144,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,   145,    90,    91,    92,    93,   386,   388,
     387,   389,    94,   265,   146,   266,   267,   147,   265,    95,
     266,   267,   268,   326,   390,    30,   391,   268,    31,    32,
     148,    33,   269,   274,    34,    35,   323,   269,   270,   392,
     394,   393,   395,   270,   396,   331,   397,    96,    97,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   149,
     416,   275,   417,    99,   276,   419,   423,   420,   424,   150,
     425,   324,   426,   271,   181,   428,   277,   429,   273,   445,
     430,   432,   431,   433,   452,   434,   531,   435,   532,    49,
      50,    96,    97,   278,   279,   182,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   274,   533,
     535,   534,   536,   453,   537,   539,   538,   540,   541,   183,
     542,   184,   547,    61,   548,   446,   447,   325,   312,   313,
     314,   315,   316,   317,   318,   185,   275,   319,   320,   276,
     550,   552,   551,   553,   565,   567,   566,   568,   569,   186,
     570,   277,   571,   578,   572,   579,   607,   610,   608,   611,
     622,   624,   623,   625,   449,   450,   454,   455,   278,   279,
     187,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   322,   188,   189,   190,   332,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   312,   313,   314,   315,   316,   317,   318,
     207,   208,   319,   320,   151,   209,   152,   210,   211,   212,
     231,   232,   233,   234,   153,   235,   236,   154,   155,   237,
     156,   157,   158,   159,   160,   238,   161,   162,   163,   164,
     165,   166,   167,   168,   239,   169,   170,   171,   240,   172,
     173,   174,   151,   241,   152,   242,   243,   175,   244,   245,
     246,   247,   153,   248,   249,   154,   155,   250,   156,   157,
     158,   159,   160,   251,   161,   162,   163,   164,   165,   166,
     167,   168,   213,   169,   170,   171,   252,   172,   173,   174,
     253,   254,   255,   256,   257,   175,   258,   259,   260,   261,
     262,   398,   327,   214,   328,   329,   330,   333,   176,   102,
     103,   104,   105,   334,   106,   335,   336,   337,   338,   215,
     339,   216,   340,   341,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   107,   177,   178,   342,   343,
     344,   345,   102,   103,   104,   105,   180,   106,   346,   347,
     365,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   348,   107,   349,
     350,   351,   352,   353,   177,   178,   228,   354,   355,   356,
     372,   357,   358,   359,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     360,   363,   364,   366,   367,   368,   138,   369,   124,   370,
     371,   373,   375,   400,   374,   376,   377,   378,   379,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   213,
     380,   381,   382,   383,   399,   401,   402,   403,   404,   405,
     406,   136,   407,   408,   409,    64,   410,   411,   412,   413,
     214,   414,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   415,   418,   421,   422,   215,   427,   216,   436,
     439,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   437,   438,   440,   441,   442,   443,     0,   444,
     448,   451,   458,   456,   457,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   230,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      42,   512,   513,     0,   515,   516,   523,   514,   517,   518,
     519,   101,    46,   524,   520,   521,   522,   525,   526,   527,
     528,   543,   530,   140,   545,   529,     0,   549,   544,   546,
     557,   554,   555,   556,   558,   559,   560,   561,     0,   562,
     563,   564,   573,   575,   574,   576,   577,   580,   581,   601,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,     0,
       0,     0,     0,     0,   602,   603,   604,   605,   606,   609,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621
};

static const yytype_int16 yycheck[] =
{
      15,    16,   120,   114,   122,    20,     0,    22,    10,     3,
       4,     5,   118,     7,     8,    30,     9,    10,    33,    34,
      35,    36,    37,    38,    39,    40,   118,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,     6,
      55,    56,    57,    58,    15,    16,     9,    10,    63,    20,
     118,    22,    13,    14,   120,     6,   122,    13,    14,    30,
       9,    10,    33,    34,    35,    36,    37,    38,    39,    40,
     118,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,   118,    55,    56,    57,    58,   120,   120,
     122,   122,    63,    54,   118,    56,    57,   118,    54,   114,
      56,    57,    63,   123,   120,     6,   122,    63,     9,    10,
     118,     6,    73,    20,     9,    10,   119,    73,    79,   120,
     120,   122,   122,    79,   120,   123,   122,   142,   143,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,   118,
     120,    48,   122,   114,    51,   120,   120,   122,   122,   118,
     120,   119,   122,   114,   118,   120,    63,   122,   114,   121,
     120,   120,   122,   122,   121,   120,   120,   122,   122,     9,
      10,   142,   143,    80,    81,   118,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,    20,   120,
     120,   122,   122,   121,   120,   120,   122,   122,   120,   118,
     122,   118,   120,   114,   122,   119,   120,   119,   135,   136,
     137,   138,   139,   140,   141,   118,    48,   144,   145,    51,
     120,   120,   122,   122,   120,   120,   122,   122,   120,   118,
     122,    63,   120,   120,   122,   122,   120,   120,   122,   122,
     120,   120,   122,   122,   119,   120,   119,   120,    80,    81,
     118,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   118,   118,   118,   123,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   135,   136,   137,   138,   139,   140,   141,
     118,   118,   144,   145,    20,   118,    22,   118,   118,   118,
     118,   118,   118,   118,    30,   118,   118,    33,    34,   118,
      36,    37,    38,    39,    40,   118,    42,    43,    44,    45,
      46,    47,    48,    49,   118,    51,    52,    53,   118,    55,
      56,    57,    20,   118,    22,   118,   118,    63,   118,   118,
     118,   118,    30,   118,   118,    33,    34,   118,    36,    37,
      38,    39,    40,   118,    42,    43,    44,    45,    46,    47,
      48,    49,    20,    51,    52,    53,   118,    55,    56,    57,
     118,   118,   118,   118,   118,    63,   118,   118,   118,   118,
     118,   124,   119,    41,   119,   119,   119,   118,   114,    15,
      16,    17,    18,   118,    20,   118,   118,   118,   118,    57,
     118,    59,   118,   118,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    41,   142,   143,   118,   118,
     118,   118,    15,    16,    17,    18,   114,    20,   118,   118,
     123,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   118,    41,   118,
     118,   118,   118,   118,   142,   143,   114,   118,   118,   118,
     123,   118,   118,   118,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     119,   119,   119,   119,   119,   119,    48,   120,   114,   120,
     120,   123,   119,   118,   123,   119,   119,   119,   119,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,    20,
     119,   123,   123,   119,   124,   118,   118,   118,   118,   118,
     118,   114,   118,   118,   118,    40,   118,   118,   118,   118,
      41,   118,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   119,   119,   119,   123,    57,   120,    59,   123,
     119,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   123,   123,   120,   120,   119,   119,    -1,   120,
     120,   120,   118,   121,   121,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   114,   118,   118,   118,    -1,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
      32,   119,   119,    -1,   119,   119,   119,   123,   120,   120,
     120,    44,    35,   119,   123,   123,   123,   119,   119,   119,
     119,   124,   119,    50,   119,   123,    -1,   120,   124,   123,
     119,   123,   123,   123,   120,   120,   119,   119,    -1,   120,
     124,   120,   119,   119,   124,   119,   119,   119,   119,   124,
     120,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,    -1,
      -1,    -1,    -1,    -1,   124,   124,   124,   124,   124,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   114,   147,     0,     3,     4,     5,     7,     8,   148,
     149,   152,   153,   154,   157,   158,   159,   162,   163,   164,
     167,   168,   169,   172,   173,   174,   177,   178,   179,    10,
       6,     9,    10,     6,     9,    10,     6,     6,   150,     9,
      10,   175,   175,     9,    10,   180,   180,     9,    10,     9,
      10,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,   114,   151,   160,   160,    15,    16,    20,    22,    30,
      33,    34,    35,    36,    37,    38,    39,    40,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      55,    56,    57,    58,    63,   114,   142,   143,   176,   114,
     165,   165,    15,    16,    17,    18,    20,    41,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   114,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   181,   114,   155,   155,   170,
     170,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,    20,    22,    30,    33,    34,    36,    37,    38,    39,
      40,    42,    43,    44,    45,    46,    47,    48,    49,    51,
      52,    53,    55,    56,    57,    63,   114,   142,   143,   161,
     114,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,    20,    41,    57,    59,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   114,   166,
     114,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,    13,    14,    54,    56,    57,    63,    73,
      79,   114,   156,   114,    20,    48,    51,    63,    80,    81,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   135,   136,   137,   138,   139,   140,   141,   144,
     145,   171,   114,   119,   119,   119,   123,   119,   119,   119,
     119,   123,   123,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     119,   120,   122,   119,   119,   123,   119,   119,   119,   120,
     120,   120,   123,   123,   123,   119,   119,   119,   119,   119,
     119,   123,   123,   119,   120,   122,   120,   122,   120,   122,
     120,   122,   120,   122,   120,   122,   120,   122,   124,   124,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   119,   120,   122,   119,   120,
     122,   119,   123,   120,   122,   120,   122,   120,   120,   122,
     120,   122,   120,   122,   120,   122,   123,   123,   123,   119,
     120,   120,   119,   119,   120,   121,   119,   120,   120,   119,
     120,   120,   121,   121,   119,   120,   121,   121,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   119,   119,   123,   119,   119,   120,   120,   120,
     123,   123,   123,   119,   119,   119,   119,   119,   119,   123,
     119,   120,   122,   120,   122,   120,   122,   120,   122,   120,
     122,   120,   122,   124,   124,   119,   123,   120,   122,   120,
     120,   122,   120,   122,   123,   123,   123,   119,   120,   120,
     119,   119,   120,   124,   120,   120,   122,   120,   122,   120,
     122,   120,   122,   119,   124,   119,   119,   119,   120,   122,
     119,   119,   120,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   124,   124,   124,   124,   124,   124,   120,   122,   123,
     120,   122,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   120,   122,   120,   122
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   146,   147,   147,   147,   148,   148,   148,   148,   148,
     148,   148,   149,   150,   150,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   152,   152,   153,   154,   155,
     155,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,   156,   157,   157,   158,   159,   160,   160,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   162,   162,   163,   164,   165,   165,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   167,   167,   168,   169,
     170,   170,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   172,   172,   173,   174,   175,   175,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   177,
     177,   178,   179,   180,   180,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     4,     0,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     5,     5,     0,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     5,     5,     0,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     5,     5,     0,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     5,     5,
       0,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     4,     4,     0,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     4,     4,     0,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* commands: commands command  */
#line 182 "l2tp_config_parse.y"
                {
		}
#line 1763 "l2tp_config_parse.c"
    break;

  case 12: /* system_command: SYSTEM MODIFY system_statements EOT  */
#line 198 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			status = l2tp_system_modify_1_svc(system_config, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "system: command failed: rc=%d", l2tp_strerror(-result));
		}
#line 1775 "l2tp_config_parse.c"
    break;

  case 15: /* system_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 214 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_TRACE_FLAGS;
			system_config.config.trace_flags = (yyvsp[0].ulnum);
		}
#line 1784 "l2tp_config_parse.c"
    break;

  case 16: /* system_statement: MAX_TUNNELS EQUALS DECSTRING  */
#line 219 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_MAX_TUNNELS;
			system_config.config.max_tunnels = (yyvsp[0].ulnum);
		}
#line 1793 "l2tp_config_parse.c"
    break;

  case 17: /* system_statement: MAX_SESSIONS EQUALS DECSTRING  */
#line 224 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_MAX_SESSIONS;
			system_config.config.max_sessions = (yyvsp[0].ulnum);
		}
#line 1802 "l2tp_config_parse.c"
    break;

  case 18: /* system_statement: DRAIN_TUNNELS EQUALS BOOL  */
#line 229 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_DRAIN_TUNNELS;
			system_config.config.drain_tunnels = (yyvsp[0].num);
		}
#line 1811 "l2tp_config_parse.c"
    break;

  case 19: /* system_statement: TUNNEL_ESTABLISH_TIMEOUT EQUALS DECSTRING  */
#line 234 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_TUNNEL_ESTABLISH_TIMEOUT;
			system_config.config.tunnel_establish_timeout = (yyvsp[0].ulnum);
		}
#line 1820 "l2tp_config_parse.c"
    break;

  case 20: /* system_statement: SESSION_ESTABLISH_TIMEOUT EQUALS DECSTRING  */
#line 239 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_SESSION_ESTABLISH_TIMEOUT;
			system_config.config.session_establish_timeout = (yyvsp[0].ulnum);
		}
#line 1829 "l2tp_config_parse.c"
    break;

  case 21: /* system_statement: TUNNEL_PERSIST_PEND_TIMEOUT EQUALS DECSTRING  */
#line 244 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_TUNNEL_PERSIST_PEND_TIMEOUT;
			system_config.config.tunnel_persist_pend_timeout = (yyvsp[0].ulnum);
		}
#line 1838 "l2tp_config_parse.c"
    break;

  case 22: /* system_statement: SESSION_PERSIST_PEND_TIMEOUT EQUALS DECSTRING  */
#line 249 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_SESSION_PERSIST_PEND_TIMEOUT;
			system_config.config.session_persist_pend_timeout = (yyvsp[0].ulnum);
		}
#line 1847 "l2tp_config_parse.c"
    break;

  case 23: /* system_statement: DENY_LOCAL_TUNNEL_CREATES EQUALS BOOL  */
#line 254 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_DENY_LOCAL_TUNNEL_CREATES;
			system_config.config.deny_local_tunnel_creates = (yyvsp[0].num);
		}
#line 1856 "l2tp_config_parse.c"
    break;

  case 24: /* system_statement: DENY_REMOTE_TUNNEL_CREATES EQUALS BOOL  */
#line 259 "l2tp_config_parse.y"
                {
			system_config.config.flags |= L2TP_API_CONFIG_FLAG_DENY_REMOTE_TUNNEL_CREATES;
			system_config.config.deny_remote_tunnel_creates = (yyvsp[0].num);
		}
#line 1865 "l2tp_config_parse.c"
    break;

  case 27: /* peer_profile_create_command: PEER PROFILE CREATE peer_profile_statements EOT  */
#line 272 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (peer_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_peer_profile_create_1_svc(peer_profile, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_PROFILE_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "peer profile create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&peer_profile, 0, sizeof(peer_profile));
		}
#line 1881 "l2tp_config_parse.c"
    break;

  case 28: /* peer_profile_modify_command: PEER PROFILE MODIFY peer_profile_statements EOT  */
#line 287 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (peer_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_peer_profile_modify_1_svc(peer_profile, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "peer profile modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&peer_profile, 0, sizeof(peer_profile));
		}
#line 1897 "l2tp_config_parse.c"
    break;

  case 31: /* peer_profile_statement: PROFILE_NAME EQUALS STRING  */
#line 307 "l2tp_config_parse.y"
                {
			peer_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 1905 "l2tp_config_parse.c"
    break;

  case 32: /* peer_profile_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 311 "l2tp_config_parse.y"
                {
			peer_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 1913 "l2tp_config_parse.c"
    break;

  case 33: /* peer_profile_statement: PEER_IPADDR EQUALS IPADDRESS  */
#line 315 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_PEER_IPADDR;
			peer_profile.peer_addr.s_addr = addr.s_addr;
		}
#line 1924 "l2tp_config_parse.c"
    break;

  case 34: /* peer_profile_statement: PEER_PORT EQUALS DECSTRING  */
#line 322 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_PEER_PORT;
			peer_profile.peer_port = (yyvsp[0].ulnum);
		}
#line 1933 "l2tp_config_parse.c"
    break;

  case 35: /* peer_profile_statement: NETMASK EQUALS IPADDRESS  */
#line 327 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_NETMASK;
			peer_profile.netmask.s_addr = addr.s_addr;
		}
#line 1944 "l2tp_config_parse.c"
    break;

  case 36: /* peer_profile_statement: LAC_LNS EQUALS STRING  */
#line 334 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_LACLNS;
			if (strcasecmp((yyvsp[0].val).buf, "lac") == 0) {
				peer_profile.we_can_be_lac = 1;
				peer_profile.we_can_be_lns = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "lns") == 0) {
				peer_profile.we_can_be_lac = 0;
				peer_profile.we_can_be_lns = 1;
			} else if ((strcasecmp((yyvsp[0].val).buf, "laclns") == 0) ||
				   (strcasecmp((yyvsp[0].val).buf, "lnslac") == 0)) {
				peer_profile.we_can_be_lac = 1;
				peer_profile.we_can_be_lns = 1;
			} else {
				yyfatal("invalid lac_lns value");
			}
		}
#line 1965 "l2tp_config_parse.c"
    break;

  case 37: /* peer_profile_statement: TUNNEL_PROFILE_NAME EQUALS STRING  */
#line 351 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_TUNNEL_PROFILE_NAME;
			peer_profile.default_tunnel_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_tunnel_profile_name.valid = 1;
		}
#line 1975 "l2tp_config_parse.c"
    break;

  case 38: /* peer_profile_statement: TUNNEL_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 357 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_TUNNEL_PROFILE_NAME;
			peer_profile.default_tunnel_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_tunnel_profile_name.valid = 1;
		}
#line 1985 "l2tp_config_parse.c"
    break;

  case 39: /* peer_profile_statement: SESSION_PROFILE_NAME EQUALS STRING  */
#line 363 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_SESSION_PROFILE_NAME;
			peer_profile.default_session_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_session_profile_name.valid = 1;
		}
#line 1995 "l2tp_config_parse.c"
    break;

  case 40: /* peer_profile_statement: SESSION_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 369 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_SESSION_PROFILE_NAME;
			peer_profile.default_session_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_session_profile_name.valid = 1;
		}
#line 2005 "l2tp_config_parse.c"
    break;

  case 41: /* peer_profile_statement: PPP_PROFILE_NAME EQUALS STRING  */
#line 375 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_PPP_PROFILE_NAME;
			peer_profile.default_ppp_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_ppp_profile_name.valid = 1;
		}
#line 2015 "l2tp_config_parse.c"
    break;

  case 42: /* peer_profile_statement: PPP_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 381 "l2tp_config_parse.y"
                {
			peer_profile.flags |= L2TP_API_PEER_PROFILE_FLAG_PPP_PROFILE_NAME;
			peer_profile.default_ppp_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			peer_profile.default_ppp_profile_name.valid = 1;
		}
#line 2025 "l2tp_config_parse.c"
    break;

  case 45: /* tunnel_profile_create_command: TUNNEL PROFILE CREATE tunnel_profile_statements EOT  */
#line 395 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (tunnel_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_tunnel_profile_create_1_svc(tunnel_profile, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_PROFILE_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "tunnel profile create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&tunnel_profile, 0, sizeof(tunnel_profile));
		}
#line 2041 "l2tp_config_parse.c"
    break;

  case 46: /* tunnel_profile_modify_command: TUNNEL PROFILE MODIFY tunnel_profile_statements EOT  */
#line 410 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (tunnel_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_tunnel_profile_modify_1_svc(tunnel_profile, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "tunnel profile modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&tunnel_profile, 0, sizeof(tunnel_profile));
		}
#line 2057 "l2tp_config_parse.c"
    break;

  case 49: /* tunnel_profile_statement: PROFILE_NAME EQUALS STRING  */
#line 430 "l2tp_config_parse.y"
                {
			tunnel_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2065 "l2tp_config_parse.c"
    break;

  case 50: /* tunnel_profile_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 434 "l2tp_config_parse.y"
                {
			tunnel_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2073 "l2tp_config_parse.c"
    break;

  case 51: /* tunnel_profile_statement: HIDE_AVPS EQUALS BOOL  */
#line 438 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_HIDE_AVPS;
			tunnel_profile.hide_avps = (yyvsp[0].num);
		}
#line 2082 "l2tp_config_parse.c"
    break;

  case 52: /* tunnel_profile_statement: AUTH_MODE EQUALS STRING  */
#line 443 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_AUTH_MODE;
			if (strcasecmp((yyvsp[0].val).buf, "none") == 0) {
				tunnel_profile.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_NONE;
			} else if (strcasecmp((yyvsp[0].val).buf, "simple") == 0) {
				tunnel_profile.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_SIMPLE;
			} else if (strcasecmp((yyvsp[0].val).buf, "challenge") == 0) {
				tunnel_profile.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_CHALLENGE;
			} else {
				yyfatal("invalid auth_mode");
			}
		}
#line 2099 "l2tp_config_parse.c"
    break;

  case 53: /* tunnel_profile_statement: FRAMING_CAP EQUALS STRING  */
#line 456 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_FRAMING_CAP;
			if (strcasecmp((yyvsp[0].val).buf, "sync") == 0) {
				tunnel_profile.framing_cap_sync = 1;
				tunnel_profile.framing_cap_async = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "async") == 0) {
				tunnel_profile.framing_cap_sync = 0;
				tunnel_profile.framing_cap_async = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				tunnel_profile.framing_cap_sync = 1;
				tunnel_profile.framing_cap_async = 1;
			} else {
				yyfatal("invalid framing_cap");
			}
		}
#line 2119 "l2tp_config_parse.c"
    break;

  case 54: /* tunnel_profile_statement: BEARER_CAP EQUALS STRING  */
#line 472 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_BEARER_CAP;
			if (strcasecmp((yyvsp[0].val).buf, "analog") == 0) {
				tunnel_profile.bearer_cap_analog = 1;
				tunnel_profile.bearer_cap_digital = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "digital") == 0) {
				tunnel_profile.bearer_cap_analog = 0;
				tunnel_profile.bearer_cap_digital = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				tunnel_profile.bearer_cap_analog = 1;
				tunnel_profile.bearer_cap_digital = 1;
			} else {
				yyfatal("invalid bearer_cap");
			}
		}
#line 2139 "l2tp_config_parse.c"
    break;

  case 55: /* tunnel_profile_statement: USE_TIEBREAKER EQUALS BOOL  */
#line 488 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_USE_TIEBREAKER;
			tunnel_profile.use_tiebreaker = (yyvsp[0].num);
		}
#line 2148 "l2tp_config_parse.c"
    break;

  case 56: /* tunnel_profile_statement: HELLO_TIMEOUT EQUALS DECSTRING  */
#line 493 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_HELLO_TIMEOUT;
			tunnel_profile.hello_timeout = (yyvsp[0].ulnum);
		}
#line 2157 "l2tp_config_parse.c"
    break;

  case 57: /* tunnel_profile_statement: MAX_RETRIES EQUALS DECSTRING  */
#line 498 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_MAX_RETRIES;
			tunnel_profile.max_retries = (yyvsp[0].ulnum);
		}
#line 2166 "l2tp_config_parse.c"
    break;

  case 58: /* tunnel_profile_statement: RX_WINDOW_SIZE EQUALS DECSTRING  */
#line 503 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_RX_WINDOW_SIZE;
			tunnel_profile.rx_window_size = (yyvsp[0].ulnum);
		}
#line 2175 "l2tp_config_parse.c"
    break;

  case 59: /* tunnel_profile_statement: TX_WINDOW_SIZE EQUALS DECSTRING  */
#line 508 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_TX_WINDOW_SIZE;
			tunnel_profile.tx_window_size = (yyvsp[0].ulnum);
		}
#line 2184 "l2tp_config_parse.c"
    break;

  case 60: /* tunnel_profile_statement: RETRY_TIMEOUT EQUALS DECSTRING  */
#line 513 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_RETRY_TIMEOUT;
			tunnel_profile.retry_timeout = (yyvsp[0].ulnum);
		}
#line 2193 "l2tp_config_parse.c"
    break;

  case 61: /* tunnel_profile_statement: IDLE_TIMEOUT EQUALS DECSTRING  */
#line 518 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_IDLE_TIMEOUT;
			tunnel_profile.idle_timeout = (yyvsp[0].ulnum);
		}
#line 2202 "l2tp_config_parse.c"
    break;

  case 62: /* tunnel_profile_statement: SECRET EQUALS STRING  */
#line 523 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_SECRET;
			tunnel_profile.secret.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.secret.valid = 1;
		}
#line 2212 "l2tp_config_parse.c"
    break;

  case 63: /* tunnel_profile_statement: SECRET EQUALS QUOTEDSTRING  */
#line 529 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_SECRET;
			tunnel_profile.secret.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.secret.valid = 1;
		}
#line 2222 "l2tp_config_parse.c"
    break;

  case 64: /* tunnel_profile_statement: ALLOW_PPP_PROXY EQUALS BOOL  */
#line 535 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_ALLOW_PPP_PROXY;
			tunnel_profile.allow_ppp_proxy = (yyvsp[0].num);
		}
#line 2231 "l2tp_config_parse.c"
    break;

  case 65: /* tunnel_profile_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 540 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_TRACE_FLAGS;
			tunnel_profile.trace_flags = (yyvsp[0].ulnum);
		}
#line 2240 "l2tp_config_parse.c"
    break;

  case 66: /* tunnel_profile_statement: USE_UDP_CHECKSUMS EQUALS BOOL  */
#line 545 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_USE_UDP_CHECKSUMS;
			tunnel_profile.use_udp_checksums = (yyvsp[0].num);
		}
#line 2249 "l2tp_config_parse.c"
    break;

  case 67: /* tunnel_profile_statement: HOST_NAME EQUALS STRING  */
#line 550 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_HOST_NAME;
			tunnel_profile.host_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.host_name.valid = 1;
		}
#line 2259 "l2tp_config_parse.c"
    break;

  case 68: /* tunnel_profile_statement: HOST_NAME EQUALS QUOTEDSTRING  */
#line 556 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_HOST_NAME;
			tunnel_profile.host_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.host_name.valid = 1;
		}
#line 2269 "l2tp_config_parse.c"
    break;

  case 69: /* tunnel_profile_statement: MAX_SESSIONS EQUALS DECSTRING  */
#line 562 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_MAX_SESSIONS;
			tunnel_profile.max_sessions = (yyvsp[0].ulnum);
		}
#line 2278 "l2tp_config_parse.c"
    break;

  case 70: /* tunnel_profile_statement: SRC_IPADDR EQUALS IPADDRESS  */
#line 567 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_OUR_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			tunnel_profile.our_addr.s_addr = addr.s_addr;
		}
#line 2289 "l2tp_config_parse.c"
    break;

  case 71: /* tunnel_profile_statement: DEST_IPADDR EQUALS IPADDRESS  */
#line 574 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PEER_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			tunnel_profile.peer_addr.s_addr = addr.s_addr;
		}
#line 2300 "l2tp_config_parse.c"
    break;

  case 72: /* tunnel_profile_statement: OUR_UDP_PORT EQUALS DECSTRING  */
#line 581 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_OUR_UDP_PORT;
			tunnel_profile.our_udp_port = (yyvsp[0].ulnum);
		}
#line 2309 "l2tp_config_parse.c"
    break;

  case 73: /* tunnel_profile_statement: PEER_UDP_PORT EQUALS DECSTRING  */
#line 586 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PEER_UDP_PORT;
			tunnel_profile.peer_udp_port = (yyvsp[0].ulnum);
		}
#line 2318 "l2tp_config_parse.c"
    break;

  case 74: /* tunnel_profile_statement: PEER_PROFILE_NAME EQUALS STRING  */
#line 591 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PEER_PROFILE_NAME;
			tunnel_profile.peer_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.peer_profile_name.valid = 1;
		}
#line 2328 "l2tp_config_parse.c"
    break;

  case 75: /* tunnel_profile_statement: PEER_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 597 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PEER_PROFILE_NAME;
			tunnel_profile.peer_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.peer_profile_name.valid = 1;
		}
#line 2338 "l2tp_config_parse.c"
    break;

  case 76: /* tunnel_profile_statement: SESSION_PROFILE_NAME EQUALS STRING  */
#line 603 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_SESSION_PROFILE_NAME;
			tunnel_profile.session_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.session_profile_name.valid = 1;
		}
#line 2348 "l2tp_config_parse.c"
    break;

  case 77: /* tunnel_profile_statement: SESSION_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 609 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_SESSION_PROFILE_NAME;
			tunnel_profile.session_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.session_profile_name.valid = 1;
		}
#line 2358 "l2tp_config_parse.c"
    break;

  case 78: /* tunnel_profile_statement: PPP_PROFILE_NAME EQUALS STRING  */
#line 615 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PPP_PROFILE_NAME;
			tunnel_profile.ppp_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.ppp_profile_name.valid = 1;
		}
#line 2368 "l2tp_config_parse.c"
    break;

  case 79: /* tunnel_profile_statement: PPP_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 621 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_PPP_PROFILE_NAME;
			tunnel_profile.ppp_profile_name.optstring_u.value = (yyvsp[0].val).buf;
			tunnel_profile.ppp_profile_name.valid = 1;
		}
#line 2378 "l2tp_config_parse.c"
    break;

  case 80: /* tunnel_profile_statement: DO_PMTU_DISCOVERY EQUALS BOOL  */
#line 627 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_DO_PMTU_DISCOVERY;
			tunnel_profile.do_pmtu_discovery = (yyvsp[0].num);
		}
#line 2387 "l2tp_config_parse.c"
    break;

  case 81: /* tunnel_profile_statement: MTU EQUALS DECSTRING  */
#line 632 "l2tp_config_parse.y"
                {
			tunnel_profile.flags |= L2TP_API_TUNNEL_PROFILE_FLAG_MTU;
			tunnel_profile.mtu = (yyvsp[0].ulnum);
		}
#line 2396 "l2tp_config_parse.c"
    break;

  case 84: /* session_profile_create_command: SESSION PROFILE CREATE session_profile_statements EOT  */
#line 645 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (session_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_session_profile_create_1_svc(session_profile, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_PROFILE_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "session profile create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&session_profile, 0, sizeof(session_profile));
		}
#line 2412 "l2tp_config_parse.c"
    break;

  case 85: /* session_profile_modify_command: SESSION PROFILE MODIFY session_profile_statements EOT  */
#line 660 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (session_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_session_profile_modify_1_svc(session_profile, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "session profile modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&session_profile, 0, sizeof(session_profile));
		}
#line 2428 "l2tp_config_parse.c"
    break;

  case 88: /* session_profile_statement: PROFILE_NAME EQUALS STRING  */
#line 680 "l2tp_config_parse.y"
                {
			session_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2436 "l2tp_config_parse.c"
    break;

  case 89: /* session_profile_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 684 "l2tp_config_parse.y"
                {
			session_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2444 "l2tp_config_parse.c"
    break;

  case 90: /* session_profile_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 688 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_TRACE_FLAGS;
			session_profile.trace_flags = (yyvsp[0].ulnum);
		}
#line 2453 "l2tp_config_parse.c"
    break;

  case 91: /* session_profile_statement: SEQUENCING_REQUIRED EQUALS BOOL  */
#line 693 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_SEQUENCING_REQUIRED;
			session_profile.sequencing_required = (yyvsp[0].num);
		}
#line 2462 "l2tp_config_parse.c"
    break;

  case 92: /* session_profile_statement: PPP_PROFILE_NAME EQUALS STRING  */
#line 698 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(session_profile.ppp_profile_name) = (yyvsp[0].val).buf;
			session_profile.ppp_profile_name.valid = 1;
		}
#line 2472 "l2tp_config_parse.c"
    break;

  case 93: /* session_profile_statement: PPP_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 704 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(session_profile.ppp_profile_name) = (yyvsp[0].val).buf;
			session_profile.ppp_profile_name.valid = 1;
		}
#line 2482 "l2tp_config_parse.c"
    break;

  case 94: /* session_profile_statement: SESSION_TYPE EQUALS STRING  */
#line 710 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_SESSION_TYPE;
			session_profile.flags |= L2TP_API_SESSION_FLAG_SESSION_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "laic") == 0) {
				session_profile.session_type = L2TP_API_SESSION_TYPE_LAIC;
			} else if (strcasecmp((yyvsp[0].val).buf, "laoc") == 0) {
				session_profile.session_type = L2TP_API_SESSION_TYPE_LAOC;
			} else if (strcasecmp((yyvsp[0].val).buf, "lnic") == 0) {
				session_profile.session_type = L2TP_API_SESSION_TYPE_LNIC;
			} else if (strcasecmp((yyvsp[0].val).buf, "lnoc") == 0) {
				session_profile.session_type = L2TP_API_SESSION_TYPE_LNOC;
			} else {
				yyfatal("Bad session type: expecting laic|laoc|lnic|lnoc");
			}
		}
#line 2502 "l2tp_config_parse.c"
    break;

  case 95: /* session_profile_statement: PRIV_GROUP_ID EQUALS STRING  */
#line 726 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_PRIV_GROUP_ID;
			OPTSTRING(session_profile.priv_group_id) = (yyvsp[0].val).buf;
			session_profile.priv_group_id.valid = 1;
		}
#line 2512 "l2tp_config_parse.c"
    break;

  case 96: /* session_profile_statement: PRIV_GROUP_ID EQUALS QUOTEDSTRING  */
#line 732 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_PRIV_GROUP_ID;
			OPTSTRING(session_profile.priv_group_id) = (yyvsp[0].val).buf;
			session_profile.priv_group_id.valid = 1;
		}
#line 2522 "l2tp_config_parse.c"
    break;

  case 97: /* session_profile_statement: FRAMING_TYPE EQUALS STRING  */
#line 738 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_FRAMING_TYPE;
			session_profile.flags |= L2TP_API_SESSION_FLAG_FRAMING_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "sync") == 0) {
				session_profile.framing_type_sync = 1;
				session_profile.framing_type_async = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "async") == 0) {
				session_profile.framing_type_sync = 0;
				session_profile.framing_type_async = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				session_profile.framing_type_sync = 1;
				session_profile.framing_type_async = 1;
			} else {
				yyfatal("invalid framing_type");
			}
		}
#line 2543 "l2tp_config_parse.c"
    break;

  case 98: /* session_profile_statement: BEARER_TYPE EQUALS STRING  */
#line 755 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_BEARER_TYPE;
			session_profile.flags |= L2TP_API_SESSION_FLAG_BEARER_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "analog") == 0) {
				session_profile.bearer_type_analog = 1;
				session_profile.bearer_type_digital = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "digital") == 0) {
				session_profile.bearer_type_analog = 0;
				session_profile.bearer_type_digital = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				session_profile.bearer_type_analog = 1;
				session_profile.bearer_type_digital = 1;
			} else {
				yyfatal("invalid bearer_type");
			}
		}
#line 2564 "l2tp_config_parse.c"
    break;

  case 99: /* session_profile_statement: MINIMUM_BPS EQUALS DECSTRING  */
#line 772 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_MINIMUM_BPS;
			session_profile.minimum_bps = (yyvsp[0].ulnum);
		}
#line 2573 "l2tp_config_parse.c"
    break;

  case 100: /* session_profile_statement: MAXIMUM_BPS EQUALS DECSTRING  */
#line 777 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_MAXIMUM_BPS;
			session_profile.maximum_bps = (yyvsp[0].ulnum);
		}
#line 2582 "l2tp_config_parse.c"
    break;

  case 101: /* session_profile_statement: CONNECT_SPEED EQUALS STRING  */
#line 782 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_CONNECT_SPEED;
			int ints[2];
			int num_matches;
			session_profile.flags |= L2TP_API_SESSION_FLAG_CONNECT_SPEED;
			num_matches = sscanf((yyvsp[0].val).buf, "%d:%d", &ints[0], &ints[1]);
			if (num_matches >= 1) {
				session_profile.rx_connect_speed = ints[0];
				session_profile.tx_connect_speed = ints[0];
				if (num_matches == 2) {
					session_profile.tx_connect_speed = ints[1];
				}
			} else {
				yyfatal("Expecting connect_speed[:tx_connect_speed]");
			}
		}
#line 2603 "l2tp_config_parse.c"
    break;

  case 102: /* session_profile_statement: USE_PPP_PROXY EQUALS BOOL  */
#line 799 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_USE_PPP_PROXY;
			session_profile.use_ppp_proxy = (yyvsp[0].num);
		}
#line 2612 "l2tp_config_parse.c"
    break;

  case 103: /* session_profile_statement: USE_SEQUENCE_NUMBERS EQUALS BOOL  */
#line 804 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_USE_SEQUENCE_NUMBERS;
			session_profile.use_sequence_numbers = (yyvsp[0].num);
		}
#line 2621 "l2tp_config_parse.c"
    break;

  case 104: /* session_profile_statement: NO_PPP EQUALS BOOL  */
#line 809 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_NO_PPP;
			session_profile.no_ppp = (yyvsp[0].num);
		}
#line 2630 "l2tp_config_parse.c"
    break;

  case 105: /* session_profile_statement: REORDER_TIMEOUT EQUALS DECSTRING  */
#line 814 "l2tp_config_parse.y"
                {
			session_profile.flags |= L2TP_API_SESSION_PROFILE_FLAG_REORDER_TIMEOUT;
			session_profile.reorder_timeout = (yyvsp[0].ulnum);
		}
#line 2639 "l2tp_config_parse.c"
    break;

  case 108: /* ppp_profile_create_command: PPP PROFILE CREATE ppp_profile_statements EOT  */
#line 827 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (ppp_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_ppp_profile_create_1_svc(ppp_profile, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_PROFILE_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "ppp profile create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&ppp_profile, 0, sizeof(ppp_profile));
		}
#line 2655 "l2tp_config_parse.c"
    break;

  case 109: /* ppp_profile_modify_command: PPP PROFILE MODIFY ppp_profile_statements EOT  */
#line 842 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			if (ppp_profile.profile_name == NULL)
				yyfatal("missing profile name");
			status = l2tp_ppp_profile_modify_1_svc(ppp_profile, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "ppp profile modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&ppp_profile, 0, sizeof(ppp_profile));
		}
#line 2671 "l2tp_config_parse.c"
    break;

  case 112: /* ppp_profile_statement: PROFILE_NAME EQUALS STRING  */
#line 862 "l2tp_config_parse.y"
                {
			ppp_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2679 "l2tp_config_parse.c"
    break;

  case 113: /* ppp_profile_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 866 "l2tp_config_parse.y"
                {
			ppp_profile.profile_name = (yyvsp[0].val).buf;
		}
#line 2687 "l2tp_config_parse.c"
    break;

  case 114: /* ppp_profile_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 870 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_TRACE_FLAGS;
			ppp_profile.trace_flags = (yyvsp[0].ulnum);
		}
#line 2696 "l2tp_config_parse.c"
    break;

  case 115: /* ppp_profile_statement: ASYNCMAP EQUALS DECSTRING  */
#line 875 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_ASYNCMAP;
			ppp_profile.asyncmap = (yyvsp[0].ulnum);
		}
#line 2705 "l2tp_config_parse.c"
    break;

  case 116: /* ppp_profile_statement: MRU EQUALS DECSTRING  */
#line 880 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_MRU;
			ppp_profile.mru = (yyvsp[0].ulnum);
		}
#line 2714 "l2tp_config_parse.c"
    break;

  case 117: /* ppp_profile_statement: MTU EQUALS DECSTRING  */
#line 885 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_MTU;
			ppp_profile.mtu = (yyvsp[0].ulnum);
		}
#line 2723 "l2tp_config_parse.c"
    break;

  case 118: /* ppp_profile_statement: USE_RADIUS EQUALS BOOL  */
#line 890 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_USE_RADIUS;
			ppp_profile.use_radius = (yyvsp[0].num);
		}
#line 2732 "l2tp_config_parse.c"
    break;

  case 119: /* ppp_profile_statement: RADIUS_HINT EQUALS STRING  */
#line 895 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_RADIUS_HINT;
			OPTSTRING(ppp_profile.radius_hint) = (yyvsp[0].val).buf;
			ppp_profile.radius_hint.valid = 1;
		}
#line 2742 "l2tp_config_parse.c"
    break;

  case 120: /* ppp_profile_statement: RADIUS_HINT EQUALS QUOTEDSTRING  */
#line 901 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_RADIUS_HINT;
			OPTSTRING(ppp_profile.radius_hint) = (yyvsp[0].val).buf;
			ppp_profile.radius_hint.valid = 1;
		}
#line 2752 "l2tp_config_parse.c"
    break;

  case 121: /* ppp_profile_statement: AUTH_PAP EQUALS BOOL  */
#line 907 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_REFUSE_PAP;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_refuse_pap = 0;
			} else {
				ppp_profile.auth_refuse_pap = -1;
			}
		}
#line 2765 "l2tp_config_parse.c"
    break;

  case 122: /* ppp_profile_statement: AUTH_CHAP EQUALS BOOL  */
#line 916 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_REFUSE_CHAP;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_refuse_chap = 0;
			} else {
				ppp_profile.auth_refuse_chap = -1;
			}
		}
#line 2778 "l2tp_config_parse.c"
    break;

  case 123: /* ppp_profile_statement: AUTH_MSCHAPV1 EQUALS BOOL  */
#line 925 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_REFUSE_MSCHAP;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_refuse_mschap = 0;
			} else {
				ppp_profile.auth_refuse_mschap = -1;
			}
		}
#line 2791 "l2tp_config_parse.c"
    break;

  case 124: /* ppp_profile_statement: AUTH_MSCHAPV2 EQUALS BOOL  */
#line 934 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_REFUSE_MSCHAPV2;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_refuse_mschapv2 = 0;
			} else {
				ppp_profile.auth_refuse_mschapv2 = -1;
			}
		}
#line 2804 "l2tp_config_parse.c"
    break;

  case 125: /* ppp_profile_statement: AUTH_EAP EQUALS BOOL  */
#line 943 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_REFUSE_EAP;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_refuse_eap = 0;
			} else {
				ppp_profile.auth_refuse_eap = -1;
			}
		}
#line 2817 "l2tp_config_parse.c"
    break;

  case 126: /* ppp_profile_statement: AUTH_NOAUTH EQUALS BOOL  */
#line 952 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_NONE;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_none = -1;
			} else {
				ppp_profile.auth_none = 0;
			}
		}
#line 2830 "l2tp_config_parse.c"
    break;

  case 127: /* ppp_profile_statement: AUTH_PEER EQUALS BOOL  */
#line 961 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_AUTH_PEER;
			if ((yyvsp[0].num)) {
				ppp_profile.auth_peer = -1;
			} else {
				ppp_profile.auth_peer = 0;
			}
		}
#line 2843 "l2tp_config_parse.c"
    break;

  case 128: /* ppp_profile_statement: SYNC_MODE EQUALS STRING  */
#line 970 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_SYNC_MODE;
			if (strcasecmp((yyvsp[0].val).buf, "sync") == 0) {
				ppp_profile.sync_mode = L2TP_API_PPP_SYNCMODE_SYNC;
			} else if (strcasecmp((yyvsp[0].val).buf, "async") == 0) {
				ppp_profile.sync_mode = L2TP_API_PPP_SYNCMODE_ASYNC;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				ppp_profile.sync_mode = L2TP_API_PPP_SYNCMODE_SYNC_ASYNC;
			} else {
				yyfatal("Bad sync mode: expecting sync|async|any");
			}
		}
#line 2860 "l2tp_config_parse.c"
    break;

  case 129: /* ppp_profile_statement: CHAP_INTERVAL EQUALS DECSTRING  */
#line 983 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_CHAP_INTERVAL;
			ppp_profile.chap_interval = (yyvsp[0].ulnum);
		}
#line 2869 "l2tp_config_parse.c"
    break;

  case 130: /* ppp_profile_statement: CHAP_MAX_CHALLENGE EQUALS DECSTRING  */
#line 988 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_CHAP_MAX_CHALLENGE;
			ppp_profile.chap_max_challenge = (yyvsp[0].ulnum);
		}
#line 2878 "l2tp_config_parse.c"
    break;

  case 131: /* ppp_profile_statement: CHAP_RESTART EQUALS DECSTRING  */
#line 993 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_CHAP_RESTART;
			ppp_profile.chap_restart = (yyvsp[0].ulnum);
		}
#line 2887 "l2tp_config_parse.c"
    break;

  case 132: /* ppp_profile_statement: PAP_MAX_AUTH_REQUESTS EQUALS DECSTRING  */
#line 998 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_PAP_MAX_AUTH_REQUESTS;
			ppp_profile.pap_max_auth_requests = (yyvsp[0].ulnum);
		}
#line 2896 "l2tp_config_parse.c"
    break;

  case 133: /* ppp_profile_statement: PAP_RESTART_INTERVAL EQUALS DECSTRING  */
#line 1003 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_PAP_RESTART_INTERVAL;
			ppp_profile.pap_restart_interval = (yyvsp[0].ulnum);
		}
#line 2905 "l2tp_config_parse.c"
    break;

  case 134: /* ppp_profile_statement: PAP_TIMEOUT EQUALS DECSTRING  */
#line 1008 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_PAP_TIMEOUT;
			ppp_profile.pap_timeout = (yyvsp[0].ulnum);
		}
#line 2914 "l2tp_config_parse.c"
    break;

  case 135: /* ppp_profile_statement: IDLE_TIMEOUT EQUALS DECSTRING  */
#line 1013 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_IDLE_TIMEOUT;
			ppp_profile.idle_timeout = (yyvsp[0].ulnum);
		}
#line 2923 "l2tp_config_parse.c"
    break;

  case 136: /* ppp_profile_statement: IPCP_MAX_CONFIG_REQUESTS EQUALS DECSTRING  */
#line 1018 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_IPCP_MAX_CONFIG_REQUESTS;
			ppp_profile.ipcp_max_config_requests = (yyvsp[0].ulnum);
		}
#line 2932 "l2tp_config_parse.c"
    break;

  case 137: /* ppp_profile_statement: IPCP_MAX_CONFIG_NAKS EQUALS DECSTRING  */
#line 1023 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_IPCP_MAX_CONFIG_NAKS;
			ppp_profile.ipcp_max_config_naks = (yyvsp[0].ulnum);
		}
#line 2941 "l2tp_config_parse.c"
    break;

  case 138: /* ppp_profile_statement: IPCP_MAX_TERMINATE_REQUESTS EQUALS DECSTRING  */
#line 1028 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_IPCP_MAX_TERMINATE_REQUESTS;
			ppp_profile.lcp_max_terminate_requests = (yyvsp[0].ulnum);
		}
#line 2950 "l2tp_config_parse.c"
    break;

  case 139: /* ppp_profile_statement: IPCP_RETRANSMIT_INTERVAL EQUALS DECSTRING  */
#line 1033 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_IPCP_RETRANSMIT_INTERVAL;
			ppp_profile.ipcp_retransmit_interval = (yyvsp[0].ulnum);
		}
#line 2959 "l2tp_config_parse.c"
    break;

  case 140: /* ppp_profile_statement: LCP_ECHO_FAILURE_COUNT EQUALS DECSTRING  */
#line 1038 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_ECHO_FAILURE_COUNT;
			ppp_profile.lcp_echo_failure_count = (yyvsp[0].ulnum);
		}
#line 2968 "l2tp_config_parse.c"
    break;

  case 141: /* ppp_profile_statement: LCP_ECHO_INTERVAL EQUALS DECSTRING  */
#line 1043 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_ECHO_INTERVAL;
			ppp_profile.lcp_echo_interval = (yyvsp[0].ulnum);
		}
#line 2977 "l2tp_config_parse.c"
    break;

  case 142: /* ppp_profile_statement: LCP_MAX_CONFIG_REQUESTS EQUALS DECSTRING  */
#line 1048 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_MAX_CONFIG_REQUESTS;
			ppp_profile.lcp_max_config_requests = (yyvsp[0].ulnum);
		}
#line 2986 "l2tp_config_parse.c"
    break;

  case 143: /* ppp_profile_statement: LCP_MAX_CONFIG_NAKS EQUALS DECSTRING  */
#line 1053 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_MAX_CONFIG_NAKS;
			ppp_profile.lcp_max_config_naks = (yyvsp[0].ulnum);
		}
#line 2995 "l2tp_config_parse.c"
    break;

  case 144: /* ppp_profile_statement: LCP_MAX_TERMINATE_REQUESTS EQUALS DECSTRING  */
#line 1058 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_MAX_TERMINATE_REQUESTS;
			ppp_profile.lcp_max_terminate_requests = (yyvsp[0].ulnum);
		}
#line 3004 "l2tp_config_parse.c"
    break;

  case 145: /* ppp_profile_statement: LCP_RETRANSMIT_INTERVAL EQUALS DECSTRING  */
#line 1063 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_LCP_RETRANSMIT_INTERVAL;
			ppp_profile.lcp_retransmit_interval = (yyvsp[0].ulnum);
		}
#line 3013 "l2tp_config_parse.c"
    break;

  case 146: /* ppp_profile_statement: MAX_CONNECT_TIME EQUALS DECSTRING  */
#line 1068 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_MAX_CONNECT_TIME;
			ppp_profile.max_connect_time = (yyvsp[0].ulnum);
		}
#line 3022 "l2tp_config_parse.c"
    break;

  case 147: /* ppp_profile_statement: MAX_FAILURE_COUNT EQUALS DECSTRING  */
#line 1073 "l2tp_config_parse.y"
                {
			ppp_profile.flags |= L2TP_API_PPP_PROFILE_FLAG_MAX_FAILURE_COUNT;
			ppp_profile.max_failure_count = (yyvsp[0].ulnum);
		}
#line 3031 "l2tp_config_parse.c"
    break;

  case 148: /* ppp_profile_statement: DNS_IPADDR_PRI EQUALS IPADDRESS  */
#line 1078 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_DNS_ADDR_1;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.dns_addr_1.s_addr = addr.s_addr;
		}
#line 3042 "l2tp_config_parse.c"
    break;

  case 149: /* ppp_profile_statement: DNS_IPADDR_SEC EQUALS IPADDRESS  */
#line 1085 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_DNS_ADDR_2;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.dns_addr_2.s_addr = addr.s_addr;
		}
#line 3053 "l2tp_config_parse.c"
    break;

  case 150: /* ppp_profile_statement: WINS_IPADDR_PRI EQUALS IPADDRESS  */
#line 1092 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_WINS_ADDR_1;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.wins_addr_1.s_addr = addr.s_addr;
		}
#line 3064 "l2tp_config_parse.c"
    break;

  case 151: /* ppp_profile_statement: WINS_IPADDR_SEC EQUALS IPADDRESS  */
#line 1099 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_WINS_ADDR_2;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.wins_addr_2.s_addr = addr.s_addr;
		}
#line 3075 "l2tp_config_parse.c"
    break;

  case 152: /* ppp_profile_statement: LOCAL_IPADDR EQUALS IPADDRESS  */
#line 1106 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_LOCAL_IP_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.local_ip_addr.s_addr = addr.s_addr;
		}
#line 3086 "l2tp_config_parse.c"
    break;

  case 153: /* ppp_profile_statement: REMOTE_IPADDR EQUALS IPADDRESS  */
#line 1113 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_PEER_IP_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			ppp_profile.peer_ip_addr.s_addr = addr.s_addr;
		}
#line 3097 "l2tp_config_parse.c"
    break;

  case 154: /* ppp_profile_statement: IP_POOL_NAME EQUALS STRING  */
#line 1120 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_IP_POOL_NAME;
			OPTSTRING(ppp_profile.ip_pool_name) = (yyvsp[0].val).buf;
			ppp_profile.ip_pool_name.valid = 1;
		}
#line 3107 "l2tp_config_parse.c"
    break;

  case 155: /* ppp_profile_statement: IP_POOL_NAME EQUALS QUOTEDSTRING  */
#line 1126 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_IP_POOL_NAME;
			OPTSTRING(ppp_profile.ip_pool_name) = (yyvsp[0].val).buf;
			ppp_profile.ip_pool_name.valid = 1;
		}
#line 3117 "l2tp_config_parse.c"
    break;

  case 156: /* ppp_profile_statement: USE_AS_DEFAULT_ROUTE EQUALS BOOL  */
#line 1132 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_USE_AS_DEFAULT_ROUTE;
			ppp_profile.use_as_default_route = (yyvsp[0].num);
		}
#line 3126 "l2tp_config_parse.c"
    break;

  case 157: /* ppp_profile_statement: MULTILINK EQUALS BOOL  */
#line 1137 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_MULTILINK;
			ppp_profile.multilink = (yyvsp[0].num);
		}
#line 3135 "l2tp_config_parse.c"
    break;

  case 158: /* ppp_profile_statement: PROXY_ARP EQUALS BOOL  */
#line 1142 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_PROXY_ARP;
			ppp_profile.proxy_arp = (yyvsp[0].num);
		}
#line 3144 "l2tp_config_parse.c"
    break;

  case 159: /* ppp_profile_statement: LOCAL_NAME EQUALS STRING  */
#line 1147 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_LOCAL_NAME;
			OPTSTRING(ppp_profile.local_name) = (yyvsp[0].val).buf;
			ppp_profile.local_name.valid = 1;
		}
#line 3154 "l2tp_config_parse.c"
    break;

  case 160: /* ppp_profile_statement: LOCAL_NAME EQUALS QUOTEDSTRING  */
#line 1153 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_LOCAL_NAME;
			OPTSTRING(ppp_profile.local_name) = (yyvsp[0].val).buf;
			ppp_profile.local_name.valid = 1;
		}
#line 3164 "l2tp_config_parse.c"
    break;

  case 161: /* ppp_profile_statement: REMOTE_NAME EQUALS STRING  */
#line 1159 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_REMOTE_NAME;
			OPTSTRING(ppp_profile.remote_name) = (yyvsp[0].val).buf;
			ppp_profile.remote_name.valid = 1;
		}
#line 3174 "l2tp_config_parse.c"
    break;

  case 162: /* ppp_profile_statement: REMOTE_NAME EQUALS QUOTEDSTRING  */
#line 1165 "l2tp_config_parse.y"
                {
			ppp_profile.flags2 |= L2TP_API_PPP_PROFILE_FLAG_REMOTE_NAME;
			OPTSTRING(ppp_profile.remote_name) = (yyvsp[0].val).buf;
			ppp_profile.remote_name.valid = 1;
		}
#line 3184 "l2tp_config_parse.c"
    break;

  case 165: /* tunnel_create_command: TUNNEL CREATE tunnel_statements EOT  */
#line 1179 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			status = l2tp_tunnel_create_1_svc(tunnel, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_TUNNEL_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "tunnel create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&tunnel, 0, sizeof(tunnel));
		}
#line 3198 "l2tp_config_parse.c"
    break;

  case 166: /* tunnel_modify_command: TUNNEL MODIFY tunnel_statements EOT  */
#line 1192 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			status = l2tp_tunnel_modify_1_svc(tunnel, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "tunnel modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&tunnel, 0, sizeof(tunnel));
		}
#line 3212 "l2tp_config_parse.c"
    break;

  case 169: /* tunnel_statement: HIDE_AVPS EQUALS BOOL  */
#line 1210 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_HIDE_AVPS;
			tunnel.hide_avps = (yyvsp[0].num);
		}
#line 3221 "l2tp_config_parse.c"
    break;

  case 170: /* tunnel_statement: SRC_IPADDR EQUALS IPADDRESS  */
#line 1215 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_OUR_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			tunnel.our_addr.s_addr = addr.s_addr;
		}
#line 3232 "l2tp_config_parse.c"
    break;

  case 171: /* tunnel_statement: DEST_IPADDR EQUALS IPADDRESS  */
#line 1222 "l2tp_config_parse.y"
                {
			struct in_addr addr;
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PEER_ADDR;
			addr.s_addr = htonl((yyvsp[0].ulnum));
			tunnel.peer_addr.s_addr = addr.s_addr;
		}
#line 3243 "l2tp_config_parse.c"
    break;

  case 172: /* tunnel_statement: CONFIG_ID EQUALS DECSTRING  */
#line 1229 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_CONFIG_ID;
			tunnel.config_id = (yyvsp[0].ulnum);
		}
#line 3252 "l2tp_config_parse.c"
    break;

  case 173: /* tunnel_statement: OUR_UDP_PORT EQUALS DECSTRING  */
#line 1234 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_OUR_UDP_PORT;
			tunnel.our_udp_port = (yyvsp[0].ulnum);
		}
#line 3261 "l2tp_config_parse.c"
    break;

  case 174: /* tunnel_statement: AUTH_MODE EQUALS STRING  */
#line 1239 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_AUTH_MODE;
			if (strcasecmp((yyvsp[0].val).buf, "none") == 0) {
				tunnel.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_NONE;
			} else if (strcasecmp((yyvsp[0].val).buf, "simple") == 0) {
				tunnel.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_SIMPLE;
			} else if (strcasecmp((yyvsp[0].val).buf, "challenge") == 0) {
				tunnel.auth_mode = L2TP_API_TUNNEL_AUTH_MODE_CHALLENGE;
			} else {
				yyfatal("invalid auth_mode");
			}
		}
#line 3278 "l2tp_config_parse.c"
    break;

  case 175: /* tunnel_statement: FRAMING_CAP EQUALS STRING  */
#line 1252 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_FRAMING_CAP;
			if (strcasecmp((yyvsp[0].val).buf, "sync") == 0) {
				tunnel.framing_cap_sync = 1;
				tunnel.framing_cap_async = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "async") == 0) {
				tunnel.framing_cap_sync = 0;
				tunnel.framing_cap_async = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				tunnel.framing_cap_sync = 1;
				tunnel.framing_cap_async = 1;
			} else {
				yyfatal("invalid framing_cap");
			}
		}
#line 3298 "l2tp_config_parse.c"
    break;

  case 176: /* tunnel_statement: BEARER_CAP EQUALS STRING  */
#line 1268 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_BEARER_CAP;
			if (strcasecmp((yyvsp[0].val).buf, "analog") == 0) {
				tunnel.bearer_cap_analog = 1;
				tunnel.bearer_cap_digital = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "digital") == 0) {
				tunnel.bearer_cap_analog = 0;
				tunnel.bearer_cap_digital = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				tunnel.bearer_cap_analog = 1;
				tunnel.bearer_cap_digital = 1;
			} else {
				yyfatal("invalid bearer_cap");
			}
		}
#line 3318 "l2tp_config_parse.c"
    break;

  case 177: /* tunnel_statement: USE_TIEBREAKER EQUALS BOOL  */
#line 1284 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_USE_TIEBREAKER;
			tunnel.use_tiebreaker = (yyvsp[0].num);
		}
#line 3327 "l2tp_config_parse.c"
    break;

  case 178: /* tunnel_statement: PERSIST EQUALS BOOL  */
#line 1289 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PERSIST;
			tunnel.persist = (yyvsp[0].num);
		}
#line 3336 "l2tp_config_parse.c"
    break;

  case 179: /* tunnel_statement: HELLO_TIMEOUT EQUALS DECSTRING  */
#line 1294 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_HELLO_TIMEOUT;
			tunnel.hello_timeout = (yyvsp[0].ulnum);
		}
#line 3345 "l2tp_config_parse.c"
    break;

  case 180: /* tunnel_statement: MAX_RETRIES EQUALS DECSTRING  */
#line 1299 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_MAX_RETRIES;
			tunnel.max_retries = (yyvsp[0].ulnum);
		}
#line 3354 "l2tp_config_parse.c"
    break;

  case 181: /* tunnel_statement: RX_WINDOW_SIZE EQUALS DECSTRING  */
#line 1304 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_RX_WINDOW_SIZE;
			tunnel.rx_window_size = (yyvsp[0].ulnum);
		}
#line 3363 "l2tp_config_parse.c"
    break;

  case 182: /* tunnel_statement: TX_WINDOW_SIZE EQUALS DECSTRING  */
#line 1309 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_TX_WINDOW_SIZE;
			tunnel.tx_window_size = (yyvsp[0].ulnum);
		}
#line 3372 "l2tp_config_parse.c"
    break;

  case 183: /* tunnel_statement: RETRY_TIMEOUT EQUALS DECSTRING  */
#line 1314 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_RETRY_TIMEOUT;
			tunnel.retry_timeout = (yyvsp[0].ulnum);
		}
#line 3381 "l2tp_config_parse.c"
    break;

  case 184: /* tunnel_statement: IDLE_TIMEOUT EQUALS DECSTRING  */
#line 1319 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_IDLE_TIMEOUT;
			tunnel.idle_timeout = (yyvsp[0].ulnum);
		}
#line 3390 "l2tp_config_parse.c"
    break;

  case 185: /* tunnel_statement: PEER_UDP_PORT EQUALS DECSTRING  */
#line 1324 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PEER_UDP_PORT;
			tunnel.peer_udp_port = (yyvsp[0].ulnum);
		}
#line 3399 "l2tp_config_parse.c"
    break;

  case 186: /* tunnel_statement: SECRET EQUALS STRING  */
#line 1329 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_SECRET;
			OPTSTRING(tunnel.secret) = (yyvsp[0].val).buf;
			tunnel.secret.valid = 1;
		}
#line 3409 "l2tp_config_parse.c"
    break;

  case 187: /* tunnel_statement: SECRET EQUALS QUOTEDSTRING  */
#line 1335 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_SECRET;
			OPTSTRING(tunnel.secret) = (yyvsp[0].val).buf;
			tunnel.secret.valid = 1;
		}
#line 3419 "l2tp_config_parse.c"
    break;

  case 188: /* tunnel_statement: ALLOW_PPP_PROXY EQUALS BOOL  */
#line 1341 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_ALLOW_PPP_PROXY;
			tunnel.allow_ppp_proxy = (yyvsp[0].num);
		}
#line 3428 "l2tp_config_parse.c"
    break;

  case 189: /* tunnel_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 1346 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_TRACE_FLAGS;
			tunnel.trace_flags = (yyvsp[0].ulnum);
		}
#line 3437 "l2tp_config_parse.c"
    break;

  case 190: /* tunnel_statement: USE_UDP_CHECKSUMS EQUALS BOOL  */
#line 1351 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_USE_UDP_CHECKSUMS;
			tunnel.use_udp_checksums = (yyvsp[0].num);
		}
#line 3446 "l2tp_config_parse.c"
    break;

  case 191: /* tunnel_statement: HOST_NAME EQUALS STRING  */
#line 1356 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_HOST_NAME;
			OPTSTRING(tunnel.host_name) = (yyvsp[0].val).buf;
			tunnel.host_name.valid = 1;
		}
#line 3456 "l2tp_config_parse.c"
    break;

  case 192: /* tunnel_statement: HOST_NAME EQUALS QUOTEDSTRING  */
#line 1362 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_HOST_NAME;
			OPTSTRING(tunnel.host_name) = (yyvsp[0].val).buf;
			tunnel.host_name.valid = 1;
		}
#line 3466 "l2tp_config_parse.c"
    break;

  case 193: /* tunnel_statement: TUNNEL_ID EQUALS DECSTRING  */
#line 1368 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_TUNNEL_ID;
			tunnel.tunnel_id = (yyvsp[0].ulnum);
		}
#line 3475 "l2tp_config_parse.c"
    break;

  case 194: /* tunnel_statement: PROFILE_NAME EQUALS STRING  */
#line 1373 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PROFILE_NAME;
			OPTSTRING(tunnel.tunnel_profile_name) = (yyvsp[0].val).buf;
			tunnel.tunnel_profile_name.valid = 1;
		}
#line 3485 "l2tp_config_parse.c"
    break;

  case 195: /* tunnel_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1379 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PROFILE_NAME;
			OPTSTRING(tunnel.tunnel_profile_name) = (yyvsp[0].val).buf;
			tunnel.tunnel_profile_name.valid = 1;
		}
#line 3495 "l2tp_config_parse.c"
    break;

  case 196: /* tunnel_statement: MAX_SESSIONS EQUALS DECSTRING  */
#line 1385 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_MAX_SESSIONS;
			tunnel.max_sessions = (yyvsp[0].ulnum);
		}
#line 3504 "l2tp_config_parse.c"
    break;

  case 197: /* tunnel_statement: TUNNEL_NAME EQUALS STRING  */
#line 1390 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_TUNNEL_NAME;
			OPTSTRING(tunnel.tunnel_name) = (yyvsp[0].val).buf;
			tunnel.tunnel_name.valid = 1;
		}
#line 3514 "l2tp_config_parse.c"
    break;

  case 198: /* tunnel_statement: TUNNEL_NAME EQUALS QUOTEDSTRING  */
#line 1396 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_TUNNEL_NAME;
			OPTSTRING(tunnel.tunnel_name) = (yyvsp[0].val).buf;
			tunnel.tunnel_name.valid = 1;
		}
#line 3524 "l2tp_config_parse.c"
    break;

  case 199: /* tunnel_statement: PEER_PROFILE_NAME EQUALS STRING  */
#line 1402 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PEER_PROFILE_NAME;
			OPTSTRING(tunnel.peer_profile_name) = (yyvsp[0].val).buf;
			tunnel.peer_profile_name.valid = 1;
		}
#line 3534 "l2tp_config_parse.c"
    break;

  case 200: /* tunnel_statement: PEER_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1408 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PEER_PROFILE_NAME;
			OPTSTRING(tunnel.peer_profile_name) = (yyvsp[0].val).buf;
			tunnel.peer_profile_name.valid = 1;
		}
#line 3544 "l2tp_config_parse.c"
    break;

  case 201: /* tunnel_statement: SESSION_PROFILE_NAME EQUALS STRING  */
#line 1414 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_SESSION_PROFILE_NAME;
			OPTSTRING(tunnel.session_profile_name) = (yyvsp[0].val).buf;
			tunnel.session_profile_name.valid = 1;
		}
#line 3554 "l2tp_config_parse.c"
    break;

  case 202: /* tunnel_statement: SESSION_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1420 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_SESSION_PROFILE_NAME;
			OPTSTRING(tunnel.session_profile_name) = (yyvsp[0].val).buf;
			tunnel.session_profile_name.valid = 1;
		}
#line 3564 "l2tp_config_parse.c"
    break;

  case 203: /* tunnel_statement: PPP_PROFILE_NAME EQUALS STRING  */
#line 1426 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(tunnel.ppp_profile_name) = (yyvsp[0].val).buf;
			tunnel.ppp_profile_name.valid = 1;
		}
#line 3574 "l2tp_config_parse.c"
    break;

  case 204: /* tunnel_statement: PPP_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1432 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(tunnel.ppp_profile_name) = (yyvsp[0].val).buf;
			tunnel.ppp_profile_name.valid = 1;
		}
#line 3584 "l2tp_config_parse.c"
    break;

  case 205: /* tunnel_statement: DO_PMTU_DISCOVERY EQUALS BOOL  */
#line 1438 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_DO_PMTU_DISCOVERY;
			tunnel.do_pmtu_discovery = (yyvsp[0].num);
		}
#line 3593 "l2tp_config_parse.c"
    break;

  case 206: /* tunnel_statement: MTU EQUALS DECSTRING  */
#line 1443 "l2tp_config_parse.y"
                {
			tunnel.flags |= L2TP_API_TUNNEL_FLAG_MTU;
			tunnel.mtu = (yyvsp[0].ulnum);
		}
#line 3602 "l2tp_config_parse.c"
    break;

  case 207: /* tunnel_statement: INTERFACE_NAME EQUALS STRING  */
#line 1448 "l2tp_config_parse.y"
                {
			tunnel.flags2 |= L2TP_API_TUNNEL_FLAG_INTERFACE_NAME;
			OPTSTRING(tunnel.interface_name) = (yyvsp[0].val).buf;
			tunnel.interface_name.valid = 1;
		}
#line 3612 "l2tp_config_parse.c"
    break;

  case 208: /* tunnel_statement: INTERFACE_NAME EQUALS QUOTEDSTRING  */
#line 1454 "l2tp_config_parse.y"
                {
			tunnel.flags2 |= L2TP_API_TUNNEL_FLAG_INTERFACE_NAME;
			OPTSTRING(tunnel.interface_name) = (yyvsp[0].val).buf;
			tunnel.interface_name.valid = 1;
		}
#line 3622 "l2tp_config_parse.c"
    break;

  case 211: /* session_create_command: SESSION CREATE session_statements EOT  */
#line 1468 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			status = l2tp_session_create_1_svc(session, &result, NULL);
			if ((status != TRUE) || ((result < 0) && (result != -L2TP_ERR_SESSION_ALREADY_EXISTS)))
				l2tp_log(LOG_ERR, "session create: command failed: rc=%d", l2tp_strerror(-result));

			memset(&session, 0, sizeof(session));
		}
#line 3636 "l2tp_config_parse.c"
    break;

  case 212: /* session_modify_command: SESSION MODIFY session_statements EOT  */
#line 1481 "l2tp_config_parse.y"
                {
			bool_t status;
			int result;
			status = l2tp_session_modify_1_svc(session, &result, NULL);
			if ((status != TRUE) || (result < 0))
				l2tp_log(LOG_ERR, "session modify: command failed: rc=%d", l2tp_strerror(-result));

			memset(&session, 0, sizeof(session));
		}
#line 3650 "l2tp_config_parse.c"
    break;

  case 215: /* session_statement: TRACE_FLAGS EQUALS DECSTRING  */
#line 1499 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_TRACE_FLAGS;
			session.trace_flags = (yyvsp[0].ulnum);
		}
#line 3659 "l2tp_config_parse.c"
    break;

  case 216: /* session_statement: SEQUENCING_REQUIRED EQUALS BOOL  */
#line 1504 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_SEQUENCING_REQUIRED;
			session.sequencing_required = (yyvsp[0].num);
		}
#line 3668 "l2tp_config_parse.c"
    break;

  case 217: /* session_statement: PPP_PROFILE_NAME EQUALS STRING  */
#line 1509 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(session.ppp_profile_name) = (yyvsp[0].val).buf;
			session.ppp_profile_name.valid = 1;
		}
#line 3678 "l2tp_config_parse.c"
    break;

  case 218: /* session_statement: PPP_PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1515 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PPP_PROFILE_NAME;
			OPTSTRING(session.ppp_profile_name) = (yyvsp[0].val).buf;
			session.ppp_profile_name.valid = 1;
		}
#line 3688 "l2tp_config_parse.c"
    break;

  case 219: /* session_statement: SESSION_TYPE EQUALS STRING  */
#line 1521 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_SESSION_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "laic") == 0) {
				session.session_type = L2TP_API_SESSION_TYPE_LAIC;
			} else if (strcasecmp((yyvsp[0].val).buf, "laoc") == 0) {
				session.session_type = L2TP_API_SESSION_TYPE_LAOC;
			} else if (strcasecmp((yyvsp[0].val).buf, "lnic") == 0) {
				session.session_type = L2TP_API_SESSION_TYPE_LNIC;
			} else if (strcasecmp((yyvsp[0].val).buf, "lnoc") == 0) {
				session.session_type = L2TP_API_SESSION_TYPE_LNOC;
			} else {
				yyfatal("Bad session type: expecting laic|laoc|lnic|lnoc");
			}
		}
#line 3707 "l2tp_config_parse.c"
    break;

  case 220: /* session_statement: PRIV_GROUP_ID EQUALS STRING  */
#line 1536 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PRIV_GROUP_ID;
			OPTSTRING(session.priv_group_id) = (yyvsp[0].val).buf;
			session.priv_group_id.valid = 1;
		}
#line 3717 "l2tp_config_parse.c"
    break;

  case 221: /* session_statement: PRIV_GROUP_ID EQUALS QUOTEDSTRING  */
#line 1542 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PRIV_GROUP_ID;
			OPTSTRING(session.priv_group_id) = (yyvsp[0].val).buf;
			session.priv_group_id.valid = 1;
		}
#line 3727 "l2tp_config_parse.c"
    break;

  case 222: /* session_statement: FRAMING_TYPE EQUALS STRING  */
#line 1548 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_FRAMING_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "sync") == 0) {
				session.framing_type_sync = 1;
				session.framing_type_async = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "async") == 0) {
				session.framing_type_sync = 0;
				session.framing_type_async = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				session.framing_type_sync = 1;
				session.framing_type_async = 1;
			} else {
				yyfatal("invalid framing_type");
			}
		}
#line 3747 "l2tp_config_parse.c"
    break;

  case 223: /* session_statement: BEARER_TYPE EQUALS STRING  */
#line 1564 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_BEARER_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "analog") == 0) {
				session.bearer_type_analog = 1;
				session.bearer_type_digital = 0;
			} else if (strcasecmp((yyvsp[0].val).buf, "digital") == 0) {
				session.bearer_type_analog = 0;
				session.bearer_type_digital = 1;
			} else if (strcasecmp((yyvsp[0].val).buf, "any") == 0) {
				session.bearer_type_analog = 1;
				session.bearer_type_digital = 1;
			} else {
				yyfatal("invalid bearer_type");
			}
		}
#line 3767 "l2tp_config_parse.c"
    break;

  case 224: /* session_statement: MINIMUM_BPS EQUALS DECSTRING  */
#line 1580 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_MINIMUM_BPS;
			session.minimum_bps = (yyvsp[0].ulnum);
		}
#line 3776 "l2tp_config_parse.c"
    break;

  case 225: /* session_statement: MAXIMUM_BPS EQUALS DECSTRING  */
#line 1585 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_MAXIMUM_BPS;
			session.maximum_bps = (yyvsp[0].ulnum);
		}
#line 3785 "l2tp_config_parse.c"
    break;

  case 226: /* session_statement: CONNECT_SPEED EQUALS STRING  */
#line 1590 "l2tp_config_parse.y"
                {
			int ints[2];
			int num_matches;
			session.flags |= L2TP_API_SESSION_FLAG_CONNECT_SPEED;
			num_matches = sscanf((yyvsp[0].val).buf, "%d:%d", &ints[0], &ints[1]);
			if (num_matches >= 1) {
				session.rx_connect_speed = ints[0];
				session.tx_connect_speed = ints[0];
				if (num_matches == 2) {
					session.tx_connect_speed = ints[1];
				}
			} else {
				yyfatal("Expecting connect_speed[:tx_connect_speed]");
			}
		}
#line 3805 "l2tp_config_parse.c"
    break;

  case 227: /* session_statement: USE_PPP_PROXY EQUALS BOOL  */
#line 1606 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USE_PPP_PROXY;
			session.use_ppp_proxy = (yyvsp[0].num);
		}
#line 3814 "l2tp_config_parse.c"
    break;

  case 228: /* session_statement: PROXY_AUTH_TYPE EQUALS STRING  */
#line 1611 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROXY_AUTH_TYPE;
			if (strcasecmp((yyvsp[0].val).buf, "text") == 0) {
				session.proxy_auth_type = L2TP_API_SESSION_PROXY_AUTH_TYPE_PLAIN_TEXT;
			} else if (strcasecmp((yyvsp[0].val).buf, "chap") == 0) {
				session.proxy_auth_type = L2TP_API_SESSION_PROXY_AUTH_TYPE_PPP_CHAP;
			} else if (strcasecmp((yyvsp[0].val).buf, "pap") == 0) {
				session.proxy_auth_type = L2TP_API_SESSION_PROXY_AUTH_TYPE_PPP_PAP;
			} else if (strcasecmp((yyvsp[0].val).buf, "none") == 0) {
				session.proxy_auth_type = L2TP_API_SESSION_PROXY_AUTH_TYPE_NO_AUTH;
			} else if (strcasecmp((yyvsp[0].val).buf, "mschap") == 0) {
				session.proxy_auth_type = L2TP_API_SESSION_PROXY_AUTH_TYPE_PPP_MSCHAPV1;
			} else {
				yyfatal("Bad auth type: expecting none|text|chap|pap|mschap");
			}
		}
#line 3835 "l2tp_config_parse.c"
    break;

  case 229: /* session_statement: PROXY_AUTH_NAME EQUALS STRING  */
#line 1628 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROXY_AUTH_NAME;
			OPTSTRING(session.proxy_auth_name) = (yyvsp[0].val).buf;
			session.proxy_auth_name.valid = 1;
		}
#line 3845 "l2tp_config_parse.c"
    break;

  case 230: /* session_statement: PROXY_AUTH_CHALLENGE EQUALS HEXSTRING  */
#line 1634 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROXY_AUTH_CHALLENGE;
			session.proxy_auth_challenge.proxy_auth_challenge_len = (yyvsp[0].val).len;
			session.proxy_auth_challenge.proxy_auth_challenge_val = (yyvsp[0].val).buf;
		}
#line 3855 "l2tp_config_parse.c"
    break;

  case 231: /* session_statement: PROXY_AUTH_RESPONSE EQUALS HEXSTRING  */
#line 1640 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROXY_AUTH_RESPONSE;
			session.proxy_auth_response.proxy_auth_response_len = (yyvsp[0].val).len;
			session.proxy_auth_response.proxy_auth_response_val = (yyvsp[0].val).buf;
		}
#line 3865 "l2tp_config_parse.c"
    break;

  case 232: /* session_statement: CALLING_NUMBER EQUALS STRING  */
#line 1646 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_CALLING_NUMBER;
			OPTSTRING(session.calling_number) = (yyvsp[0].val).buf;
			session.calling_number.valid = 1;
		}
#line 3875 "l2tp_config_parse.c"
    break;

  case 233: /* session_statement: CALLING_NUMBER EQUALS DECSTRING  */
#line 1652 "l2tp_config_parse.y"
                {
			char str[16];
			session.flags |= L2TP_API_SESSION_FLAG_CALLING_NUMBER;
			sprintf(str, "%lu", (yyvsp[0].ulnum));
			OPTSTRING(session.calling_number) = strdup(str);
			session.calling_number.valid = 1;
		}
#line 3887 "l2tp_config_parse.c"
    break;

  case 234: /* session_statement: CALLED_NUMBER EQUALS STRING  */
#line 1660 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_CALLED_NUMBER;
			OPTSTRING(session.called_number) = (yyvsp[0].val).buf;
			session.called_number.valid = 1;
		}
#line 3897 "l2tp_config_parse.c"
    break;

  case 235: /* session_statement: CALLED_NUMBER EQUALS DECSTRING  */
#line 1666 "l2tp_config_parse.y"
                {
			char str[16];
			session.flags |= L2TP_API_SESSION_FLAG_CALLED_NUMBER;
			sprintf(str, "%lu", (yyvsp[0].ulnum));
			OPTSTRING(session.called_number) = strdup(str);
			session.called_number.valid = 1;
		}
#line 3909 "l2tp_config_parse.c"
    break;

  case 236: /* session_statement: SUB_ADDRESS EQUALS STRING  */
#line 1674 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_SUB_ADDRESS;
			OPTSTRING(session.sub_address) = (yyvsp[0].val).buf;
			session.sub_address.valid = 1;
		}
#line 3919 "l2tp_config_parse.c"
    break;

  case 237: /* session_statement: SUB_ADDRESS EQUALS DECSTRING  */
#line 1680 "l2tp_config_parse.y"
                {
			char str[16];
			session.flags |= L2TP_API_SESSION_FLAG_SUB_ADDRESS;
			sprintf(str, "%lu", (yyvsp[0].ulnum));
			OPTSTRING(session.sub_address) = strdup(str);
			session.sub_address.valid = 1;
		}
#line 3931 "l2tp_config_parse.c"
    break;

  case 238: /* session_statement: INITIAL_RCVD_LCP_CONFREQ EQUALS HEXSTRING  */
#line 1688 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_INITIAL_RCVD_LCP_CONFREQ;
			session.initial_rcvd_lcp_confreq.initial_rcvd_lcp_confreq_len = (yyvsp[0].val).len;
			session.initial_rcvd_lcp_confreq.initial_rcvd_lcp_confreq_val = (yyvsp[0].val).buf;
		}
#line 3941 "l2tp_config_parse.c"
    break;

  case 239: /* session_statement: LAST_SENT_LCP_CONFREQ EQUALS HEXSTRING  */
#line 1694 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_LAST_SENT_LCP_CONFREQ;
			session.last_sent_lcp_confreq.last_sent_lcp_confreq_len = (yyvsp[0].val).len;
			session.last_sent_lcp_confreq.last_sent_lcp_confreq_val = (yyvsp[0].val).buf;
		}
#line 3951 "l2tp_config_parse.c"
    break;

  case 240: /* session_statement: LAST_RCVD_LCP_CONFREQ EQUALS HEXSTRING  */
#line 1700 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_LAST_RCVD_LCP_CONFREQ;
			session.last_rcvd_lcp_confreq.last_rcvd_lcp_confreq_len = (yyvsp[0].val).len;
			session.last_rcvd_lcp_confreq.last_rcvd_lcp_confreq_val = (yyvsp[0].val).buf;
		}
#line 3961 "l2tp_config_parse.c"
    break;

  case 241: /* session_statement: USER_NAME EQUALS STRING  */
#line 1706 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USER_NAME;
			OPTSTRING(session.user_name) = (yyvsp[0].val).buf;
			session.user_name.valid = 1;
		}
#line 3971 "l2tp_config_parse.c"
    break;

  case 242: /* session_statement: USER_NAME EQUALS QUOTEDSTRING  */
#line 1712 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USER_NAME;
			OPTSTRING(session.user_name) = (yyvsp[0].val).buf;
			session.user_name.valid = 1;
		}
#line 3981 "l2tp_config_parse.c"
    break;

  case 243: /* session_statement: USER_PASSWORD EQUALS STRING  */
#line 1718 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USER_PASSWORD;
			OPTSTRING(session.user_password) = (yyvsp[0].val).buf;
			session.user_password.valid = 1;
		}
#line 3991 "l2tp_config_parse.c"
    break;

  case 244: /* session_statement: USER_PASSWORD EQUALS QUOTEDSTRING  */
#line 1724 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USER_PASSWORD;
			OPTSTRING(session.user_password) = (yyvsp[0].val).buf;
			session.user_password.valid = 1;
		}
#line 4001 "l2tp_config_parse.c"
    break;

  case 245: /* session_statement: USE_SEQUENCE_NUMBERS EQUALS BOOL  */
#line 1730 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_USE_SEQUENCE_NUMBERS;
			session.use_sequence_numbers = (yyvsp[0].num);
		}
#line 4010 "l2tp_config_parse.c"
    break;

  case 246: /* session_statement: NO_PPP EQUALS BOOL  */
#line 1735 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_NO_PPP;
			session.no_ppp = (yyvsp[0].num);
		}
#line 4019 "l2tp_config_parse.c"
    break;

  case 247: /* session_statement: REORDER_TIMEOUT EQUALS DECSTRING  */
#line 1740 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_REORDER_TIMEOUT;
			session.reorder_timeout = (yyvsp[0].ulnum);
		}
#line 4028 "l2tp_config_parse.c"
    break;

  case 248: /* session_statement: TUNNEL_NAME EQUALS STRING  */
#line 1745 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_TUNNEL_NAME;
			OPTSTRING(session.tunnel_name) = (yyvsp[0].val).buf;
			session.tunnel_name.valid = 1;
		}
#line 4038 "l2tp_config_parse.c"
    break;

  case 249: /* session_statement: TUNNEL_NAME EQUALS QUOTEDSTRING  */
#line 1751 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_TUNNEL_NAME;
			OPTSTRING(session.tunnel_name) = (yyvsp[0].val).buf;
			session.tunnel_name.valid = 1;
		}
#line 4048 "l2tp_config_parse.c"
    break;

  case 250: /* session_statement: TUNNEL_ID EQUALS DECSTRING  */
#line 1757 "l2tp_config_parse.y"
                {
			session.tunnel_id = (yyvsp[0].ulnum);
		}
#line 4056 "l2tp_config_parse.c"
    break;

  case 251: /* session_statement: SESSION_NAME EQUALS STRING  */
#line 1761 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_SESSION_NAME;
			OPTSTRING(session.session_name) = (yyvsp[0].val).buf;
			session.session_name.valid = 1;
		}
#line 4066 "l2tp_config_parse.c"
    break;

  case 252: /* session_statement: SESSION_NAME EQUALS QUOTEDSTRING  */
#line 1767 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_SESSION_NAME;
			OPTSTRING(session.session_name) = (yyvsp[0].val).buf;
			session.session_name.valid = 1;
		}
#line 4076 "l2tp_config_parse.c"
    break;

  case 253: /* session_statement: SESSION_ID EQUALS DECSTRING  */
#line 1773 "l2tp_config_parse.y"
                {
			session.session_id = (yyvsp[0].ulnum);
		}
#line 4084 "l2tp_config_parse.c"
    break;

  case 254: /* session_statement: INTERFACE_NAME EQUALS STRING  */
#line 1777 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_INTERFACE_NAME;
			OPTSTRING(session.interface_name) = (yyvsp[0].val).buf;
			session.interface_name.valid = 1;
		}
#line 4094 "l2tp_config_parse.c"
    break;

  case 255: /* session_statement: INTERFACE_NAME EQUALS QUOTEDSTRING  */
#line 1783 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_INTERFACE_NAME;
			OPTSTRING(session.interface_name) = (yyvsp[0].val).buf;
			session.interface_name.valid = 1;
		}
#line 4104 "l2tp_config_parse.c"
    break;

  case 256: /* session_statement: PROFILE_NAME EQUALS STRING  */
#line 1789 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROFILE_NAME;
			OPTSTRING(session.profile_name) = (yyvsp[0].val).buf;
			session.profile_name.valid = 1;
		}
#line 4114 "l2tp_config_parse.c"
    break;

  case 257: /* session_statement: PROFILE_NAME EQUALS QUOTEDSTRING  */
#line 1795 "l2tp_config_parse.y"
                {
			session.flags |= L2TP_API_SESSION_FLAG_PROFILE_NAME;
			OPTSTRING(session.profile_name) = (yyvsp[0].val).buf;
			session.profile_name.valid = 1;
		}
#line 4124 "l2tp_config_parse.c"
    break;


#line 4128 "l2tp_config_parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1802 "l2tp_config_parse.y"


